<?php
/***************************************************************************
*                           admin_statistics.php
*                            -------------------
*   begin                : Sat, Aug 31, 2002
*   copyright            : (C) 2002 Meik Sievertsen
*   email                : acyd.burn@gmx.de
*
*   $Id: admin_statistics.php,v 2.1.1 2002/09/05 acyd_burn Exp $
*
*
***************************************************************************/

/***************************************************************************
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
***************************************************************************/

define('IN_PHPBB', true);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Statistics'][' '] = $filename . '?mode=manage';
	$module['Statistics'][' '] = $filename . '?mode=config';
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('pagestart.' . $phpEx);

$stats_config = array();

$sql = 'SELECT *
FROM ' . STATS_CONFIG_TABLE;
	 
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not query statistics config table', '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$stats_config[$row['config_name']] = $row['config_value'];
}

include($phpbb_root_path . 'includes/functions_stats.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_statistics.' . $phpEx);

//
// Init Vars
//
$params = array(
	'mode' => 'mode',
	'submit' => 'submit',
	'module_id' => POST_FORUM_URL
);

while( list($var, $param) = @each($params) )
{
	( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )? $$var = ( !empty($HTTP_POST_VARS[$param]) ) ? $HTTP_POST_VARS[$param] : $HTTP_GET_VARS[$param] : $$var = '';
}

$message = '';
$templated = true;

function gen_auth_select($default_auth_value)
{
	global $lang;
	
	$auth_levels = array('ALL', 'REG', 'ADMIN');
	$auth_const = array(AUTH_ALL, AUTH_REG, AUTH_ADMIN);

	$select_list = '<select name="auth_fields">';

	for($i = 0; $i < count($auth_levels); $i++)
	{
		$selected = ( $default_auth_value == $auth_const[$i] ) ? ' selected="selected"' : '';
		$select_list .= '<option value="' . $auth_const[$i] . '"' . $selected . '>' . $lang['Forum_' . $auth_levels[$i]] . '</option>';
	}
	$select_list .= '</select>';

	return ($select_list);
}

function renumber_order()
{
	global $db;

	$sql = "SELECT module_id FROM " . MODULES_TABLE . "
	ORDER BY display_order ASC";
	
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't get list of Modules", "", __LINE__, __FILE__, $sql);
	}

	$i = 10;
	$inc = 10;

	while( $row = $db->sql_fetchrow($result) )
	{
		$sql = "UPDATE " . MODULES_TABLE . "
		SET display_order = " . $i . "
		WHERE module_id = " . $row['module_id'];

		if( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't update order fields", "", __LINE__, __FILE__, $sql);
		}
		$i += 10;
	}
}

if ($mode == 'order')
{
	//
	// Change order of modules in the DB
	//
	$move = intval($HTTP_GET_VARS['move']);

	$sql = "UPDATE " . MODULES_TABLE . "
	SET display_order = display_order + $move
	WHERE module_id = " . $module_id;

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't change Module order", "", __LINE__, __FILE__, $sql);
	}

	renumber_order();
		
	$mode = 'manage';
}

if ($submit && $mode == 'config')
{
	if ( !empty($HTTP_POST_VARS['return_limit_set']) )
	{
		$update_value = ( !empty($HTTP_POST_VARS['return_limit_set']) ) ? $HTTP_POST_VARS['return_limit_set'] : $update_value = '';

		if ($stats_config['return_limit'] != $update_value)
		{
			$sql = "UPDATE " . STATS_CONFIG_TABLE . "
			SET config_value = '$update_value'
			WHERE (config_name = 'return_limit')";

			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
			}
			
			$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Return_Limit'];
		}
	}

	if ( !empty($HTTP_POST_VARS['clear_cache_set']) )
	{
		$sql = "UPDATE " . MODULES_TABLE . "
		SET module_info_time = 0,
		module_data_time = 0";

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}

		$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Clear_Cache'];
	}
	
	if ( !empty($HTTP_POST_VARS['modules_dir_set']) )
	{
		$update_value = ( !empty($HTTP_POST_VARS['modules_dir_set']) ) ? $HTTP_POST_VARS['modules_dir_set'] : $update_value = '';
	
		if ($stats_config['modules_dir'] != $update_value)
		{
			$sql = "UPDATE " . STATS_CONFIG_TABLE . "
			SET config_value = '$update_value'
			WHERE (config_name = 'modules_dir')";

			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
			}

			$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Modules_Dir'];
		}
	}
}

if ($mode == 'config')
{
	$template->set_filenames(array(
		'body' => 'admin/stat_config_body.tpl')
	);
	
	$stats_config = array();

	$sql = 'SELECT *
	FROM ' . STATS_CONFIG_TABLE;
	 
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query statistics config table', '', __LINE__, __FILE__, $sql);
	}

	while ($row = $db->sql_fetchrow($result))
	{
		$stats_config[$row['config_name']] = $row['config_value'];
	}

	$template->assign_vars(array(
		'L_RETURN_LIMIT' => $lang['Return_Limit'],
		'L_RETURN_LIMIT_DESC' => $lang['Return_Limit_Desc'],
		'L_CLEAR_CACHE' => $lang['Clear_Cache'],
		'L_CLEAR_CACHE_DESC' => $lang['Clear_Cache_Desc'],
		'L_MODULES_DIR' => $lang['Modules_Dir'],
		'L_MODULES_DIR_DESC' => $lang['Modules_Dir_Desc'],

		'L_MESSAGES' => $lang['Messages'],
		'L_RESET' => $lang['Reset'],
		'L_SUBMIT' => $lang['Submit'],

		'L_STATS_CONFIG' => $lang['Statistics_Configuration'],
		'MESSAGE' => $message,

		'RETURN_LIMIT' => $stats_config['return_limit'],
		'MODULES_DIR' => $stats_config['modules_dir'],

		'S_ACTION' => append_sid("admin_statistics.$phpEx?mode=config"))
	);
}

//
// Manage Modules
//
if ($mode == 'manage')
{
	$template->set_filenames(array(
		'body' => 'admin/stat_manage_modules.tpl')
	);
		
	$sql = "SELECT MAX(display_order) as max, MIN(display_order) as min
	FROM " . MODULES_TABLE;

	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
	}

	$row = $db->sql_fetchrow($result);

	$curr_max = $row['max'];
	$curr_min = $row['min'];
		
	//
	// Update Module List
	//
	update_module_list();

	$sql = "SELECT *
	FROM " . MODULES_TABLE . "
	ORDER BY display_order ASC";
	
	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
	}

	$rows = $db->sql_fetchrowset($result);
	$num_rows = $db->sql_numrows($result);
		
	for ($i = 0; $i < $num_rows; $i++)
	{
		$row_class = ( !($i%2) ) ? $theme['td_class1'] : $theme['td_class2'];

		$module_info = get_module_info($rows[$i]['module_id']);
		$move_up = '';
		$move_down = '';
		$edit_install = '';
		
		if ($rows[$i]['display_order'] != $curr_min)
		{
			$link = append_sid("admin_statistics.$phpEx?mode=order&amp;move=-15&amp;" . POST_FORUM_URL . "=" . $rows[$i]['module_id']);
			$move_up = '<a href="' . $link . '">' . $lang['Move_Up'] . '</a>';
		}

		if ($rows[$i]['display_order'] != $curr_max) 
		{
			$link = append_sid("admin_statistics.$phpEx?mode=order&amp;move=15&amp;" . POST_FORUM_URL . "=" . $rows[$i]['module_id']);
			$move_down = '<a href="' . $link . '">' . $lang['Move_Down'] . '</a>';
		}

		if (intval($rows[$i]['installed']) == 1)
		{
			$edit_install = '<a href="' . append_sid("admin_statistics.$phpEx?mode=edit&amp;" . POST_FORUM_URL . "=" . $rows[$i]['module_id']) . '">' . $lang['Edit'] . '</a>';
		}
		else
		{
			$edit_install = '<a href="' . append_sid("admin_statistics.$phpEx?mode=install&amp;" . POST_FORUM_URL . "=" . $rows[$i]['module_id']) . '">' . $lang['Install'] . '</a>';
		}

		$template->assign_block_vars('modulerow', array(
			'ROW_CLASS' => $row_class,
			'NAME' => $module_info['name'],
			'DNAME' => $rows[$i]['name'],
			'STATE' => (intval($rows[$i]['active']) == 1) ? $lang['Active'] : $lang['Not_Active'],
			'UPDATE_TIME' => $rows[$i]['update_time'],
			'U_MOVE_UP' => $move_up,
			'U_MOVE_DOWN' => $move_down,
			'U_EDIT' => $edit_install)
		);
	}
	
	$template->assign_vars(array(
		'L_STATS_MANAGE' => $lang['Statistics_Modules'],
		'L_MESSAGES' => $lang['Messages'],
		'L_NAME' => $lang['Name'],
		'L_DNAME' => $lang['Directory_Name'],
		'L_STATUS' => $lang['Status'],
		'L_UPDATE_TIME' => $lang['Update_Time'],

		'MESSAGE' => $message)
	);
}

if ($mode == 'install')
{
	$errored = false;
	$templated = false;

	$module_info = get_module_info($module_id);

	// Need to use inline print functions here to take care of dynamic things with the sql parse.
	// A place is made for them to show up fine without taking header time.
	print '<h3>' . $lang['Install'] . ' : ' . $module_info['name'] . '</h4>';
	print '<br>';
		
	include($phpbb_root_path.'includes/sql_parse.'.$phpEx);
	include($phpbb_root_path.'includes/db.'.$phpEx);

	$available_dbms = array(
		"mysql" => array(
			"SCHEMA" => "install_mysql", 
			"DELIM" => ";",
			"DELIM_BASIC" => ";",
			"COMMENTS" => "remove_remarks"
		), 
		"mysql4" => array(
			"SCHEMA" => "install_mysql", 
			"DELIM" => ";", 
			"DELIM_BASIC" => ";",
			"COMMENTS" => "remove_remarks"
		),
		"mssql" => array(
			"SCHEMA" => "install_mssql", 
			"DELIM" => "GO", 
			"DELIM_BASIC" => ";",
			"COMMENTS" => "remove_remarks"
		),
		"mssql-odbc" =>	array(
			"SCHEMA" => "install_mssql", 
			"DELIM" => "GO",
			"DELIM_BASIC" => ";",
			"COMMENTS" => "remove_remarks"
		),
		"postgres" => array(
			"LABEL" => "PostgreSQL 7.x",
			"SCHEMA" => "install_postgres", 
			"DELIM" => ";", 
			"DELIM_BASIC" => ";",
			"COMMENTS" => "remove_remarks"
		)
	);

	$dbms_file = $phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_info['dname'] . '/' . $available_dbms[$dbms]['SCHEMA'] . '.sql';

	$remove_remarks = $available_dbms[$dbms]['COMMENTS'];;
	$delimiter = $available_dbms[$dbms]['DELIM']; 
	$delimiter_basic = $available_dbms[$dbms]['DELIM_BASIC']; 

	$sql = true;

	if ( !($fp = @fopen($dbms_file, 'r')) )
	{
		print "<br />No SQL File found... expected: " . $dbms_file . "<br />";
		print "No need to install any SQL specific things.<br />";
		$sql = false;
	}

	if ($sql)
	{
		fclose($fp);
		$sql_query = @fread(@fopen($dbms_file, 'r'), @filesize($dbms_file));
		$sql_query = preg_replace('/phpbb_/', $table_prefix, $sql_query);

		$sql_query = $remove_remarks($sql_query);
		$sql_query = split_sql_file($sql_query, $delimiter);

		$sql_count = count($sql_query);

		if ($sql_count == 0)
		{
			print "<br />SQL File empty... no need to install any SQL specific things.<br />";
		}

		for($i = 0; $i < $sql_count; $i++)
		{
			print "Running :: " . $sql_query[$i];
			flush();

			if ( !($result = $db->sql_query($sql_query[$i])) )
			{
				$errored = true;
				$error = $db->sql_error();
				print " -> <b>FAILED</b> ---> <u>" . $error['message'] . "</u><br /><br />\n\n";
			}
			else
			{
				print " -> <b><span class=\"ok\">COMPLETED</span></b><br /><br />\n\n";
			}
		}
	}
	
	print '<br /><br /><br />Module Name: ' . $module_info['name'];
	print '<br />Module Version: ' . $module_info['version'];
	print '<br />Module Author: ' . $module_info['author'];
	print '<br />Author Email: ' . $module_info['email'];
	print '<br />Author URL: ' . $module_info['url'];
	print '<br /><br /><br />' . $module_info['extra_info'];

	if (!$errored)
	{
		$sql = "UPDATE " . MODULES_TABLE . "
		SET installed = 1
		WHERE module_id = " . $module_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}
	}
	else
	{
		print '<br><font color="red">' . $lang['Module_Install_Error'] . '</font>';
	}

	print '<br /><br /><br /><a href="' . append_sid("admin_statistics.$phpEx?mode=manage") . '">Back to the Management Screen</a>';
}

if ($submit && $mode == 'edit')
{
	$auth_value = ( !empty($HTTP_POST_VARS['auth_fields']) ) ? intval($HTTP_POST_VARS['auth_fields']) : 0;

	$sql = "UPDATE " . MODULES_TABLE . "
	SET auth_value = " . $auth_value . "
	WHERE module_id = " . $module_id;

	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
	}

	$module_info = get_module_info($module_id);
			
	$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Auth_Settings_Updated'] . ' : ' . $module_info['name'];

	$update_value = ( isset($HTTP_POST_VARS['active']) ) ? intval($HTTP_POST_VARS['active']) : 0;

	if (intval($module_info['active']) != $update_value)
	{
		$sql = "UPDATE " . MODULES_TABLE . "
		SET active = " . intval($update_value) . "
		WHERE module_id = " . $module_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}
			
		$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Active'] . ' : ' . $module_info['name'];
	}

	$update_value = ( isset($HTTP_POST_VARS['updatetime']) ) ? intval($HTTP_POST_VARS['updatetime']) : 0;
	
	if ($row['update_time'] != $update_value)
	{
		$sql = "UPDATE " . MODULES_TABLE . "
		SET update_time = " . intval($update_value) . "
		WHERE module_id = " . $module_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}
			
		$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Update_Time'] . ' : ' . $module_info['name'];
	}

	if ( isset($HTTP_POST_VARS['uninstall']) && (intval($HTTP_POST_VARS['uninstall']) == 0))
	{
		$sql = "UPDATE " . MODULES_TABLE . "
		SET installed = 0, active = 0
		WHERE module_id = " . $module_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}
		
		$message .= '<br>' . $lang['Updated'] . ' : ' . $lang['Uninstall'] . ' : ' . $module_info['name'];
	}
}

if ($mode == 'edit')
{
	$template->set_filenames(array(
		'body' => 'admin/stat_edit_module.tpl')
	);
		
	//
	// Set up Preview Page
	//
	$module_info = get_module_info($module_id);

	$auth_value = intval($module_info['auth_value']);
		
	$template->assign_vars(array(
		'ACTIVE_CHECKED_YES' => (intval($module_info['active']) == 1) ? 'checked="checked"' : '',
		'ACTIVE_CHECKED_NO' => (intval($module_info['active']) == 0) ? 'checked="checked"' : '',
		'UPDATE_TIME' => $module_info['update_time'],
		'MODULE_DNAME' => $module_info['dname'],
		'S_AUTH_SELECT' => gen_auth_select($auth_value),
		'MODULE_NAME' => $module_info['name'])
	);

	//
	// Compile the Module without using cache functions
	//
	$return_limit = $stats_config['return_limit'];
				
	@include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.' . $phpEx);
	@include($phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_info['dname'] . '/lang_' . $board_config['default_lang'] . '/lang.' . $phpEx);
	include($phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_info['dname'] . '/module.php');
				
	$template->set_filenames(array(
		'preview' => './../' . $phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_info['dname'] . '/module.tpl')
	);

	$template->assign_vars(array(
		'MESSAGE' => $message,
		'L_ACTIVE' => $lang['Active'],
		'L_ACTIVE_DESC' => $lang['Active_Desc'],
		'L_AUTH_SETTINGS' => $lang['Permissions'],
		'L_EDIT' => $lang['Edit'],
		'L_UPDATE_TIME2' => $lang['Update_Time2'],
		'L_UPDATE_TIME_DESC' => $lang['Update_Time_Desc'],
		'L_YES' => $lang['Yes'],
		'L_NO' => $lang['No'],
		'L_UNINSTALL' => $lang['Uninstall'],
		'L_UNINSTALL_DESC' => $lang['Uninstall_Desc'],
		'L_MESSAGES' => $lang['Messages'],
		'L_SUBMIT' => $lang['Submit'],
		'L_RESET' => $lang['Reset'],
		'L_UPDATE_TIME' => $lang['Update_Time'],
		'L_PREVIEW' => $lang['Preview'],

		'S_ACTION' => append_sid("admin_statistics.$phpEx?mode=edit&amp;" . POST_FORUM_URL . "=$module_id"))
	);

	$template->assign_var_from_handle('PREVIEW_MODULE', 'preview');
}

$template->assign_vars(array(
	'VIEWED_INFO' => sprintf($lang['Viewed_Info'], $stats_config['page_views']),
	'INSTALL_INFO' => sprintf($lang['Install_Info'], create_date($board_config['default_dateformat'], $board_config['board_startdate'], $board_config['board_timezone'])),
	'VERSION_INFO' => sprintf($lang['Version_Info'], $stats_config['version']))
);

if ($templated)
{
	$template->pparse('body');

	include('./page_footer_admin.'.$phpEx);
}

?>