<?php
/***************************************************************************
 *                            album_upload.php
 *                           -------------------
 *   begin                : Saturday, July 13, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor_xp@hotmail.com
 *
 *   $Id: album_upload.php,v 1.6.7 2002/11/17, 22:39:06 Smartor Exp $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'album_mod/album_common.'.$phpEx);

error_reporting(E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables
set_magic_quotes_runtime(0); // Disable magic_quotes_runtime

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

//
// Get Album Configuration
//
$sql = "SELECT * FROM " . TABLE_ALBUM_CONFIG;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album config information", "", __LINE__, __FILE__, $sql);
}

while( $row = $db->sql_fetchrow($result) )
{
	$album_config_name = $row['config_name'];
	$album_config_value = $row['config_value'];
	$album_config[$album_config_name] = $album_config_value;
}

// Check Upload Level
$user_level = $userdata['user_level'];

if ($user_level == 2)
{
	$user_level = 0;
}

if ($album_config['upload_level'] > -1)
{
	if (!$userdata['session_logged_in'])
	{
		$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
		header($header_location . append_sid("login.$phpEx?redirect=album_upload.$phpEx", true));
		exit;
	}

	if ($user_level < $album_config['upload_level'])
	{
		message_die(GENERAL_MESSAGE, $lang['Not_allowed_to_upload_album']);
	}
}
// END Check Upload Level

$cat_id = (isset($HTTP_GET_VARS['cat_id'])) ? $HTTP_GET_VARS['cat_id'] : 1;

// Check Category Locked
if ($user_level != ADMIN)
{
	$sql = "SELECT * FROM ".TABLE_ALBUM_CAT." WHERE cat_id=$cat_id";
	if(!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, "Could not query Album Category information", "", __LINE__, __FILE__, $sql);
	}
	$catrow = $db->sql_fetchrow($result);

	if ($catrow['cat_title'] == '')
	{
		message_die(GENERAL_MESSAGE, 'This category not found');
	}

	if ($catrow['cat_lock'])
	{
		message_die(GENERAL_MESSAGE, $lang['Category_locked']);
	}
}
// END Check Category Locked

// Check Upload Quota
$sql = "SELECT id FROM " . TABLE_ALBUM;
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, "Could not query Album information", "", __LINE__, __FILE__, $sql);
}
$total_pics = $db->sql_numrows($result);
if ($total_pics >= $album_config['max_pics'])
{
	message_die(GENERAL_ERROR, $lang['Album_full']);
}
// END Check Upload Quota

if ( !isset($HTTP_POST_VARS['title']) or !isset($HTTP_POST_FILES['file']) or !isset($HTTP_POST_VARS['sid']) )
{
	// Output the page
	$page_title = $lang['Upload_New_Pic'];
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	$template->set_filenames(array(
		'body' => 'album_upload_body.tpl')
	);
	make_jumpbox('viewforum.'.$phpEx);

	$template->assign_vars(array(
		'L_ALBUM' => $lang['Album'],
		'ALBUM_NOTE' => __ALBUM__,
		'U_ALBUM' => append_sid("album.$phpEx?cat_id=$cat_id"),
		'L_UPLOAD_PIC' => $lang['Upload_New_Pic'],
		'L_TITLE' => $lang['Pic_Title'],
		'L_TITLE_EXPLAIN' => $lang ['Pic_Title_Explain'],
		'L_PIC_UPLOAD' => $lang['Pic_Upload'],
		'L_PIC_UPLOAD_EXPLAIN' => sprintf($lang['Pic_Upload_Explain'], $album_config['max_file_size'], $album_config['max_width'], $album_config['max_height']),
		'S_UPLOAD_ACTION' => append_sid("album_upload.$phpEx?cat_id=$cat_id"),		
		'L_RESET' => $lang['Reset'],
		'L_SUBMIT' => $lang['Submit'],
		'SID' => $userdata['session_id'],
		) // end array
	);

	$template->pparse('body');

	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

}
else // Do Upload
{
	//
	// Let's do an overall check for settings/versions which would prevent
	// us from doing file uploads....
	//
	$ini_val = ( @phpversion() >= '4.0.0' ) ? 'ini_get' : 'get_cfg_var';

	// Get Upload Info
	$filetype = $HTTP_POST_FILES['file']['type'];
	$filesize = $HTTP_POST_FILES['file']['size'];
	$filetmp = $HTTP_POST_FILES['file']['tmp_name'];
	$time = time();
	$filename = ALBUM_PREFIX . $userdata['user_id'] . '_' . $time;
	$title = htmlspecialchars(trim($HTTP_POST_VARS['title']));
	$sid = $HTTP_POST_VARS['sid'];
	$username = $userdata['username'];
	$user_id = $userdata['user_id'];

	// Check Invalid Upload
	if ( ($filesize < 1) or ($filesize > $album_config['max_file_size']) or ( ($filetype != 'image/gif') and ($filetype != 'image/jpeg') and ($filetype != 'image/jpg') and ($filetype != 'image/pjpeg') and ($filetype != 'image/png') and ($filetype != 'image/x-png') ) )
	{
		message_die(GENERAL_ERROR, $lang['Invalid_upload']);
	}

	// Now attach the file extension
	switch ($filetype)
	{
		case 'image/gif': $filename .= '.gif'; break;
		case 'image/jpg': $filename .= '.jpg'; break;
		case 'image/jpeg': $filename .= '.jpg'; break;
		case 'image/pjpeg': $filename .= '.jpg'; break;
		case 'image/png': $filename .= '.png'; break;
		case 'image/x-png': $filename .= '.png'; break;
	}

	// Move uploaded file to the upload directory
	if ( @$ini_val('open_basedir') != '' )
	{
		if ( @phpversion() < '4.0.3' )
		{
			message_die(GENERAL_ERROR, 'open_basedir is set and your PHP version does not allow move_uploaded_file', '', __LINE__, __FILE__);
		}

		$move_file = 'move_uploaded_file';
	}
	else
	{
		$move_file = 'copy';
	}

	$move_file($filetmp, ALBUM_UPLOAD_PATH . $filename);

	@chmod(ALBUM_UPLOAD_PATH . $filename, 0777);

	// Yes, I can check the image size
	$pic_size = getimagesize(ALBUM_UPLOAD_PATH . $filename);
	$pic_width = $pic_size[0];
	$pic_height = $pic_size[1];
	if ( ($pic_width > $album_config['max_width']) or ($pic_height > $album_config['max_height']) )
	{
		@unlink(ALBUM_UPLOAD_PATH . $filename);
		message_die(GENERAL_ERROR, $lang['Image_too_big'] . $pic_width.'x'.$pic_height);
	}
	
	// Update the database
	$sql = "INSERT INTO " . TABLE_ALBUM . " (filename, title, user_id, username, timestamp, cat_id) VALUES ('$filename', '$title', '$user_id', '".mysql_escape_string($username)."', '$time', '$cat_id')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, "Could not insert information into the database", "", __LINE__, __FILE__, $sql);
	}

	// Complete... now send a message to user
	$template->assign_vars(array(
		'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("album.$phpEx?cat_id=$cat_id") . '">')
	);

	$message = $lang['Album_upload_successful'] . "<br /><br />" . sprintf($lang['Click_return_album'], "<a href=\"" . append_sid("album.$phpEx?cat_id=$cat_id") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_index'], "<a href=\"" . append_sid("index.$phpEx") . "\">", "</a>");

	message_die(GENERAL_MESSAGE, $message);

}

?>