#
# phpBB2 - MySQL schema
#
# $Id: mysql_schema.sql,v 1.17.2.6 2002/07/29 12:24:19 dougk_ff7 Exp $
# $Mdify: mysql_basic.sql,v 2002/09/07 12:10:29 Eazycom.net Exp 

#
# Table structure for table 'phpbb_auth_access'
#
CREATE TABLE phpbb_auth_access (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   auth_view tinyint(1) DEFAULT '0' NOT NULL,
   auth_read tinyint(1) DEFAULT '0' NOT NULL,
   auth_post tinyint(1) DEFAULT '0' NOT NULL,
   auth_reply tinyint(1) DEFAULT '0' NOT NULL,
   auth_edit tinyint(1) DEFAULT '0' NOT NULL,
   auth_delete tinyint(1) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(1) DEFAULT '0' NOT NULL,
   auth_announce tinyint(1) DEFAULT '0' NOT NULL,
   auth_globalannounce tinyint(1),
   auth_vote tinyint(1) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(1) DEFAULT '0' NOT NULL,
   auth_attachments tinyint(1) DEFAULT '0' NOT NULL,
   auth_mod tinyint(1) DEFAULT '0' NOT NULL, 
   auth_download tinyint(1) DEFAULT '0' NOT NULL,  
   auth_ban tinyint(1) DEFAULT '0',
   auth_greencard tinyint(1) DEFAULT '0',
   auth_bluecard tinyint(1) DEFAULT '0',
   KEY group_id (group_id),
   KEY forum_id (forum_id)
);


#
# Table structure for table 'phpbb_user_group'
#
CREATE TABLE phpbb_user_group (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   user_pending tinyint(1), 
   KEY group_id (group_id),
   KEY user_id (user_id)
);

#
# Table structure for table 'phpbb_groups'
#
CREATE TABLE phpbb_groups (
   group_id mediumint(8) NOT NULL auto_increment,
   group_type tinyint(4) DEFAULT '1' NOT NULL, 
   group_name varchar(40) NOT NULL,
   group_description varchar(255) NOT NULL,
   group_moderator mediumint(8) DEFAULT '0' NOT NULL, 
   group_single_user tinyint(1) DEFAULT '1' NOT NULL, 
   PRIMARY KEY (group_id), 
   KEY group_single_user (group_single_user)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_banlist'
#
CREATE TABLE phpbb_banlist (
   ban_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   ban_userid mediumint(8) NOT NULL,
   ban_ip char(8) NOT NULL,
   ban_email varchar(255),
   PRIMARY KEY (ban_id), 
   KEY ban_ip_user_id (ban_ip, ban_userid)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_categories'
#
CREATE TABLE phpbb_categories (
   cat_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   cat_on CHAR(1) DEFAULT '1' NOT NULL,
   cat_title varchar(100),
   cat_order mediumint(8) UNSIGNED NOT NULL,
   parent_forum_id SMALLINT(5) UNSIGNED DEFAULT '0' NOT NULL,
   cat_hier_level TINYINT UNSIGNED DEFAULT '0' NOT NULL,
   PRIMARY KEY (cat_id), 
   KEY cat_order (cat_order)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_config'
#
CREATE TABLE phpbb_config ( 
    config_name varchar(255) NOT NULL, 
    config_value varchar(255) NOT NULL, 
    PRIMARY KEY (config_name)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_disallow'
#
CREATE TABLE phpbb_disallow (
   disallow_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   disallow_username varchar(25),
   PRIMARY KEY (disallow_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_forum_prune'
#
CREATE TABLE phpbb_forum_prune (
   prune_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   forum_id smallint(5) UNSIGNED NOT NULL,
   prune_days tinyint(4) UNSIGNED NOT NULL,
   prune_freq tinyint(4) UNSIGNED NOT NULL,
   PRIMARY KEY(prune_id),
   KEY forum_id (forum_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_forums'
#
CREATE TABLE phpbb_forums (
   forum_id smallint(5) UNSIGNED NOT NULL,
   cat_id mediumint(8) UNSIGNED NOT NULL,
   forum_name varchar(150),
   forum_desc text,
   forum_status tinyint(4) DEFAULT '0' NOT NULL, 
   forum_order mediumint(8) UNSIGNED DEFAULT '1' NOT NULL,
   forum_posts mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_topics mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_hier_level TINYINT UNSIGNED DEFAULT '0' NOT NULL,
   forum_issub TINYINT(1) DEFAULT '0' NOT NULL,
   prune_next int(11),
   prune_enable tinyint(1) DEFAULT '0' NOT NULL,
   auth_view tinyint(2) DEFAULT '0' NOT NULL,
   auth_read tinyint(2) DEFAULT '0' NOT NULL,
   auth_post tinyint(2) DEFAULT '0' NOT NULL,
   auth_reply tinyint(2) DEFAULT '0' NOT NULL,
   auth_edit tinyint(2) DEFAULT '0' NOT NULL,
   auth_delete tinyint(2) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(2) DEFAULT '0' NOT NULL,
   auth_announce tinyint(2) DEFAULT '0' NOT NULL,
   auth_globalannounce tinyint(2) DEFAULT '3' NOT NULL,
   auth_vote tinyint(2) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(2) DEFAULT '0' NOT NULL,
   auth_attachments tinyint(2) DEFAULT '0' NOT NULL,
   auth_download tinyint(2) DEFAULT '0' NOT NULL, 
   auth_ban tinyint(2) DEFAULT '3',
   auth_greencard tinyint(2) DEFAULT '5',
   auth_bluecard tinyint(2) DEFAULT '1', 
   events_forum tinyint(1) DEFAULT '0',
   auth_rate tinyint(2) NOT NULL default '-1',
   PRIMARY KEY (forum_id),
   KEY forums_order (forum_order),
   KEY cat_id (cat_id), 
   KEY forum_last_post_id (forum_last_post_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_posts'
#
CREATE TABLE phpbb_posts (
   post_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   topic_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   poster_id mediumint(8) DEFAULT '0' NOT NULL,
   post_time int(11) DEFAULT '0' NOT NULL,
   poster_ip char(8) NOT NULL, 
   post_username varchar(25), 
   enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   enable_html tinyint(1) DEFAULT '0' NOT NULL,
   enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   enable_sig tinyint(1) DEFAULT '1' NOT NULL, 
   post_edit_time int(11),
   post_edit_count smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   post_icon tinyint(2) UNSIGNED DEFAULT '1' NOT NULL, 
   post_bluecard tinyint(1),
   post_attachment tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (post_id),
   KEY forum_id (forum_id),
   KEY topic_id (topic_id),
   KEY poster_id (poster_id), 
   KEY post_time (post_time)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_posts_text'
#
CREATE TABLE phpbb_posts_text (
   post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   bbcode_uid char(10) NOT NULL,
   post_subject char(60),
   post_text text,
   PRIMARY KEY (post_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_privmsgs'
#
CREATE TABLE phpbb_privmsgs (
   privmsgs_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   privmsgs_type tinyint(4) DEFAULT '0' NOT NULL,
   privmsgs_subject varchar(255) DEFAULT '0' NOT NULL,
   privmsgs_from_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_to_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_date int(11) DEFAULT '0' NOT NULL,
   privmsgs_ip char(8) NOT NULL,
   privmsgs_enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_enable_html tinyint(1) DEFAULT '0' NOT NULL,
   privmsgs_enable_smilies tinyint(1) DEFAULT '1' NOT NULL, 
   privmsgs_attach_sig tinyint(1) DEFAULT '1' NOT NULL, 
   privmsgs_attachment tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (privmsgs_id),
   KEY privmsgs_from_userid (privmsgs_from_userid),
   KEY privmsgs_to_userid (privmsgs_to_userid)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_privmsgs_text'
#
CREATE TABLE phpbb_privmsgs_text (
   privmsgs_text_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   privmsgs_bbcode_uid char(10) DEFAULT '0' NOT NULL, 
   privmsgs_text text,
   PRIMARY KEY (privmsgs_text_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_ranks'
#
CREATE TABLE phpbb_ranks (
   rank_id smallint(5) UNSIGNED NOT NULL auto_increment,
   rank_title varchar(50) NOT NULL,
   rank_min mediumint(8) DEFAULT '0' NOT NULL,
   rank_special tinyint(1) DEFAULT '0',
   rank_image varchar(255),
   PRIMARY KEY (rank_id) 
);


# --------------------------------------------------------
#
# Table structure for table `phpbb_search_results`
#
CREATE TABLE phpbb_search_results (
  search_id int(11) UNSIGNED NOT NULL default '0',
  session_id char(32) NOT NULL default '',
  search_array text NOT NULL,
  PRIMARY KEY  (search_id),
  KEY session_id (session_id)
);


# --------------------------------------------------------
#
# Table structure for table `phpbb_search_wordlist`
#
CREATE TABLE phpbb_search_wordlist (
  word_text varchar(50) binary NOT NULL default '',
  word_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  word_common tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY (word_text), 
  KEY word_id (word_id)
);

# --------------------------------------------------------
#
# Table structure for table `phpbb_search_wordmatch`
#
CREATE TABLE phpbb_search_wordmatch (
  post_id mediumint(8) UNSIGNED NOT NULL default '0',
  word_id mediumint(8) UNSIGNED NOT NULL default '0',
  title_match tinyint(1) NOT NULL default '0',
  KEY word_id (word_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_sessions'
#
# Note that if you're running 3.23.x you may want to make
# this table a type HEAP. This type of table is stored
# within system memory and therefore for big busy boards
# is likely to be noticeably faster than continually
# writing to disk ... 
#
# I must admit I read about this type on vB's board.
# Hey, I never said you cannot get basic ideas from
# competing boards, just that I find it's best not to
# look at any code ... !
#
CREATE TABLE phpbb_sessions (
   session_id char(32) DEFAULT '' NOT NULL,
   session_user_id mediumint(8) DEFAULT '0' NOT NULL,
   session_start int(11) DEFAULT '0' NOT NULL,
   session_time int(11) DEFAULT '0' NOT NULL,
   session_ip char(8) DEFAULT '0' NOT NULL,
   session_page int(11) DEFAULT '0' NOT NULL,
   session_logged_in tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (session_id),
   KEY session_user_id (session_user_id),
   KEY session_id_ip_user_id (session_id, session_ip, session_user_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_smilies'
#
CREATE TABLE phpbb_smilies (
   smilies_id smallint(5) UNSIGNED NOT NULL auto_increment,
   code varchar(50),
   smile_url varchar(100),
   emoticon varchar(75),
   PRIMARY KEY (smilies_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_themes'
#
CREATE TABLE phpbb_themes (
   themes_id mediumint(8) UNSIGNED NOT NULL auto_increment, 
   template_name varchar(30) NOT NULL default '', 
   style_name varchar(30) NOT NULL default '',
   head_stylesheet varchar(100) default NULL,
   body_background varchar(100) default NULL,
   body_bgcolor varchar(6) default NULL,
   body_text varchar(6) default NULL,
   body_link varchar(6) default NULL,
   body_vlink varchar(6) default NULL,
   body_alink varchar(6) default NULL,
   body_hlink varchar(6) default NULL,
   tr_color1 varchar(6) default NULL,
   tr_color2 varchar(6) default NULL,
   tr_color3 varchar(6) default NULL,
   tr_class1 varchar(25) default NULL,
   tr_class2 varchar(25) default NULL,
   tr_class3 varchar(25) default NULL,
   th_color1 varchar(6) default NULL,
   th_color2 varchar(6) default NULL,
   th_color3 varchar(6) default NULL,
   th_class1 varchar(25) default NULL,
   th_class2 varchar(25) default NULL,
   th_class3 varchar(25) default NULL,
   td_color1 varchar(6) default NULL,
   td_color2 varchar(6) default NULL,
   td_color3 varchar(6) default NULL,
   td_class1 varchar(25) default NULL,
   td_class2 varchar(25) default NULL,
   td_class3 varchar(25) default NULL,
   fontface1 varchar(50) default NULL,
   fontface2 varchar(50) default NULL,
   fontface3 varchar(50) default NULL,
   fontsize1 tinyint(4) default NULL,
   fontsize2 tinyint(4) default NULL,
   fontsize3 tinyint(4) default NULL,
   fontcolor1 varchar(6) default NULL,
   fontcolor2 varchar(6) default NULL,
   fontcolor3 varchar(6) default NULL,
   fontcolor4 varchar(6) default NULL,
   span_class1 varchar(25) default NULL,
   span_class2 varchar(25) default NULL,
   span_class3 varchar(25) default NULL, 
   img_size_poll smallint(5) UNSIGNED, 
   img_size_privmsg smallint(5) UNSIGNED, 
   PRIMARY KEY  (themes_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_themes_name'
#
CREATE TABLE phpbb_themes_name (
   themes_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   tr_color1_name char(50),
   tr_color2_name char(50),
   tr_color3_name char(50),
   tr_class1_name char(50),
   tr_class2_name char(50),
   tr_class3_name char(50),
   th_color1_name char(50),
   th_color2_name char(50),
   th_color3_name char(50),
   th_class1_name char(50),
   th_class2_name char(50),
   th_class3_name char(50),
   td_color1_name char(50),
   td_color2_name char(50),
   td_color3_name char(50),
   td_class1_name char(50),
   td_class2_name char(50),
   td_class3_name char(50),
   fontface1_name char(50),
   fontface2_name char(50),
   fontface3_name char(50),
   fontsize1_name char(50),
   fontsize2_name char(50),
   fontsize3_name char(50),
   fontcolor1_name char(50),
   fontcolor2_name char(50),
   fontcolor3_name char(50),
   fontcolor4_name char(50),
   span_class1_name char(50),
   span_class2_name char(50),
   span_class3_name char(50),
   PRIMARY KEY (themes_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_topics'
#
CREATE TABLE phpbb_topics (
   topic_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   forum_id smallint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_title char(60) NOT NULL,
   topic_poster mediumint(8) DEFAULT '0' NOT NULL,
   topic_time int(11) DEFAULT '0' NOT NULL,
   topic_views mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_replies mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_status tinyint(3) DEFAULT '0' NOT NULL,
   topic_vote tinyint(1) DEFAULT '0' NOT NULL,
   topic_type tinyint(3) DEFAULT '0' NOT NULL,
   topic_first_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_moved_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_icon tinyint(2) UNSIGNED DEFAULT '1' NOT NULL,
   topic_attachment tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (topic_id),
   KEY forum_id (forum_id),
   KEY topic_moved_id (topic_moved_id),
   KEY topic_status (topic_status), 
   KEY topic_type (topic_type) 
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_topics_watch'
#
CREATE TABLE phpbb_topics_watch (
  topic_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  user_id mediumint(8) NOT NULL DEFAULT '0',
  notify_status tinyint(1) NOT NULL default '0',
  KEY topic_id (topic_id),
  KEY user_id (user_id), 
  KEY notify_status (notify_status)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_users'
#
CREATE TABLE phpbb_users (
   user_id mediumint(8) NOT NULL,
   user_active tinyint(1) DEFAULT '1',
   username varchar(25) NOT NULL,
   user_password varchar(32) NOT NULL,
   user_session_time int(11) DEFAULT '0' NOT NULL, 
   user_session_page smallint(5) DEFAULT '0' NOT NULL, 
   user_lastvisit int(11) DEFAULT '0' NOT NULL, 
   user_regdate int(11) DEFAULT '0' NOT NULL, 
   user_level tinyint(4) DEFAULT '0',
   user_posts mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   user_timezone decimal(4,2) DEFAULT '0' NOT NULL,
   user_style tinyint(4),
   user_lang varchar(255),
   user_dateformat varchar(14) DEFAULT 'd M Y H:i' NOT NULL,
   user_new_privmsg smallint(5) UNSIGNED DEFAULT '0' NOT NULL, 
   user_unread_privmsg smallint(5) UNSIGNED DEFAULT '0' NOT NULL, 
   user_last_privmsg int(11) DEFAULT '0' NOT NULL, 
   user_emailtime int(11), 
   user_viewemail tinyint(1), 
   user_attachsig tinyint(1), 
   user_allowhtml tinyint(1) DEFAULT '1', 
   user_allowbbcode tinyint(1) DEFAULT '1', 
   user_allowsmile tinyint(1) DEFAULT '1', 
   user_allowavatar tinyint(1) DEFAULT '1' NOT NULL, 
   user_allow_pm tinyint(1) DEFAULT '1' NOT NULL, 
   user_allow_mass_pm tinyint(1) DEFAULT '2' NOT NULL, 
   user_allow_viewonline tinyint(1) DEFAULT '1' NOT NULL, 
   user_notify tinyint(1) DEFAULT '1' NOT NULL,
   user_notify_pm tinyint(1) DEFAULT '1' NOT NULL, 
   user_popup_pm tinyint(1) DEFAULT '0' NOT NULL, 
   user_rank int(11) DEFAULT '0',
   user_avatar varchar(100),
   user_avatar_type tinyint(4) DEFAULT '0' NOT NULL, 
   user_email varchar(255),
   user_icq varchar(15),
   user_website varchar(100),
   user_from varchar(100),
   user_sig text,
   user_sig_bbcode_uid char(10),
   user_aim varchar(255),
   user_yim varchar(255),
   user_msnm varchar(255),
   user_occ varchar(100),
   user_interests varchar(255),
   user_actkey varchar(32),
   user_newpasswd varchar(32),
   user_lastlogon int(11) DEFAULT '0', 
   user_gender tinyint, 
   user_birthday int DEFAULT '999999' NOT NULL,
   user_next_birthday_greeting int DEFAULT '0' NOT NULL,
   user_points mediumint(8) UNSIGNED NOT NULL,
   user_photo varchar(100) default NULL,
   user_photo_type tinyint(4) NOT NULL default '0',
   PRIMARY KEY (user_id), 
   KEY user_session_time (user_session_time)
);

UPDATE phpbb_users SET user_lastlogon=user_lastvisit;

# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_desc'
#
CREATE TABLE phpbb_vote_desc (
  vote_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  topic_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_text text NOT NULL,
  vote_start int(11) NOT NULL DEFAULT '0',
  vote_length int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY  (vote_id),
  KEY topic_id (topic_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_results'
#
CREATE TABLE phpbb_vote_results (
  vote_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_option_id tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  vote_option_text varchar(255) NOT NULL,
  vote_result int(11) NOT NULL DEFAULT '0',
  KEY vote_option_id (vote_option_id),
  KEY vote_id (vote_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_voters'
#
CREATE TABLE phpbb_vote_voters (
  vote_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_user_id mediumint(8) NOT NULL DEFAULT '0',
  vote_user_ip char(8) NOT NULL,
  KEY vote_id (vote_id),
  KEY vote_user_id (vote_user_id),
  KEY vote_user_ip (vote_user_ip)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_words'
#
CREATE TABLE phpbb_words (
   word_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   word char(100) NOT NULL,
   replacement char(100) NOT NULL,
   PRIMARY KEY (word_id)
);

# Table structure for table 'phpbb_attachments_config' 2.3.5
#
CREATE TABLE phpbb_attachments_config (
  config_name varchar(255) NOT NULL,
  config_value varchar(255) NOT NULL,
  PRIMARY KEY (config_name)
);

#
# Table structure for table 'phpbb_forbidden_extensions'
#
CREATE TABLE phpbb_forbidden_extensions (
  ext_id mediumint(8) UNSIGNED NOT NULL auto_increment, 
  extension varchar(100) NOT NULL, 
  PRIMARY KEY (ext_id)
);

#
# Table structure for table 'phpbb_extension_groups'
#
CREATE TABLE phpbb_extension_groups (
  group_id mediumint(8) NOT NULL auto_increment,
  group_name char(20) NOT NULL,
  cat_id tinyint(2) DEFAULT '0' NOT NULL, 
  allow_group tinyint(1) DEFAULT '0' NOT NULL,
  download_mode tinyint(1) UNSIGNED DEFAULT '1' NOT NULL,
  upload_icon varchar(100) DEFAULT '',
  max_filesize int(20) DEFAULT '0' NOT NULL,
  forum_permissions varchar(255) default '' NOT NULL,
  PRIMARY KEY group_id (group_id)
);

#
# Table structure for table 'phpbb_extensions'
#
CREATE TABLE phpbb_extensions (
  ext_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  group_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  extension varchar(100) NOT NULL,
  comment varchar(100),
  PRIMARY KEY ext_id (ext_id)
);

#
# Table structure for table 'phpbb_attachments_desc'
#
CREATE TABLE phpbb_attachments_desc (
  attach_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  physical_filename varchar(255) NOT NULL,
  real_filename varchar(255) NOT NULL,
  download_count mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  comment varchar(255),
  extension varchar(100),
  mimetype varchar(100),
  filesize int(20) NOT NULL,
  filetime int(11) DEFAULT '0' NOT NULL,
  thumbnail tinyint(1) DEFAULT '0' NOT NULL,
  PRIMARY KEY (attach_id),
  KEY filetime (filetime),
  KEY physical_filename (physical_filename(10)),
  KEY filesize (filesize)
);

#
# Table structure for table 'phpbb_attachments'
#
CREATE TABLE phpbb_attachments (
  attach_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL, 
  post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL, 
  privmsgs_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  user_id_1 mediumint(8) NOT NULL,
  user_id_2 mediumint(8) NOT NULL,
  KEY attach_id_post_id (attach_id, post_id),
  KEY attach_id_privmsgs_id (attach_id, privmsgs_id)
); 

#
# Table structure for table 'phpbb_quota_limits'
#
CREATE TABLE phpbb_quota_limits (
  quota_limit_id mediumint(8) unsigned NOT NULL auto_increment,
  quota_desc varchar(20) NOT NULL default '',
  quota_limit int(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (quota_limit_id)
);

#
# Table structure for table 'phpbb_attach_quota'
#
CREATE TABLE phpbb_attach_quota (
  user_id mediumint(8) unsigned NOT NULL default '0',
  group_id mediumint(8) unsigned NOT NULL default '0',
  quota_type smallint(2) NOT NULL default '0',
  quota_limit_id mediumint(8) unsigned NOT NULL default '0',
  KEY quota_type (quota_type)
);

#---sub category
CREATE TABLE phpbb_cat_rel_cat_parents (
  cat_id mediumint(8) unsigned NOT NULL default '0',
  parent_cat_id mediumint(8) unsigned NOT NULL default '0',
PRIMARY KEY  (cat_id,parent_cat_id)
);

CREATE TABLE phpbb_cat_rel_forum_parents (
  cat_id mediumint(8) unsigned NOT NULL default '0',
  parent_forum_id smallint(5) unsigned NOT NULL default '0',
PRIMARY KEY  (cat_id,parent_forum_id)
);

#---my calendar
CREATE TABLE phpbb_mycalendar (
  cal_id int(12) NOT NULL auto_increment,
  topic_id int(20) NOT NULL default '0',
  cal_date datetime NOT NULL default '2000-00-00 00:00:00',
  cal_interval tinyint(3) NOT NULL default '1',
  cal_interval_units enum('DAY','WEEK','MONTH','YEAR') NOT NULL default 'DAY',
  cal_repeat tinyint(3) NOT NULL default '1',
  forum_id int(5) NOT NULL default '0',
  PRIMARY KEY  (cal_id),
  UNIQUE KEY topic_id (topic_id)
) TYPE=MyISAM;

#---Site History
CREATE TABLE phpbb_site_history (
  date int (11)  not null, 
  reg mediumint(8) not null, 
  hidden mediumint(8) not null, 
  guests mediumint(8) not null, 
  new_topics mediumint(8) not null, 
  new_posts mediumint(8) not null, 
UNIQUE (date)
);

#---Links
CREATE TABLE phpbb_links_cat (
  id bigint(20) NOT NULL auto_increment,
  name text NOT NULL,
  hidden tinyint(2) NOT NULL default '1',
  owner mediumint(10) NOT NULL default '0',
  UNIQUE KEY id (id)
) TYPE=MyISAM;

CREATE TABLE phpbb_links_url (
  id bigint(20) NOT NULL auto_increment,
  url text NOT NULL,
  name text NOT NULL,
  description text NOT NULL,
  added int(11) default NULL,
  owner mediumint(8) NOT NULL default '0',
  clickcounter int(12) NOT NULL default '0',
  lastclickid mediumint(8) NOT NULL default '0',
  lastclicktime int(11) NOT NULL default '0',
  bbcode_uid varchar(10) NOT NULL default '',
  enable_bbcode tinyint(1) NOT NULL default '1',
  user varchar(12) not null default '0',
  banner varchar(150),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

CREATE TABLE phpbb_links_urlincat (
  id bigint(20) NOT NULL auto_increment,
  url_id bigint(20) NOT NULL default '0',
  cat_id bigint(20) NOT NULL default '0',
  pos mediumint(10) NOT NULL default '9999',
  UNIQUE KEY id (id)
) TYPE=MyISAM;

CREATE TABLE phpbb_links_config (
  links_anony char(1) NOT NULL default '1',
  links_bbcode char(1) NOT NULL default '1',
  d_category char(3) NOT NULL default '1',
  img_width char(3) NOT NULL default '88',
  img_height char(3) NOT NULL default '31',
  img_s_off tinyint(1) default '0',
  top_enable char(1) NOT NULL default '1',
  top_number char(3) NOT NULL default '5'
) TYPE=MyISAM;

#---̹ ַ
CREATE TABLE phpbb_album (
	id int(11) NOT NULL auto_increment,
	filename varchar(99) NOT NULL,
	title varchar(255) NOT NULL,
	user_id mediumint(8) NOT NULL,
	username varchar(25) NOT NULL,
	timestamp int(10) unsigned NOT NULL,
	cat_id mediumint(8) DEFAULT '1' NOT NULL,
    view_time int(11) unsigned NOT NULL default '0',
	PRIMARY KEY (id));

CREATE TABLE phpbb_album_config (
	config_name varchar(255) NOT NULL,
	config_value varchar(255) NOT NULL,
	PRIMARY KEY (config_name));

CREATE TABLE phpbb_album_cat (
	cat_id mediumint(8) NOT NULL auto_increment,
	cat_title varchar(50) NOT NULL,
	cat_lock tinyint(1) DEFAULT '0' NOT NULL,
	PRIMARY KEY (cat_id));

CREATE TABLE phpbb_album_comment (
    no int unsigned default '0' auto_increment,
    id int(10) unsigned not null,
    user_id mediumint(8) not null,
    username varchar(25) not null,
    comment text not null,
    time int unsigned,
 PRIMARY KEY (no)
);

#--- Rate Topics
CREATE TABLE phpbb_rate_config (
  config_name varchar(255) NOT NULL default '',
  config_value varchar(255) NOT NULL default '',
  PRIMARY KEY  (config_name)
) TYPE=MyISAM;

CREATE TABLE phpbb_rate_results (
  user_id mediumint(8) unsigned NOT NULL default '0',
  topic_id mediumint(8) unsigned NOT NULL default '0',
  rating mediumint(8) unsigned NOT NULL default '0',
  rater_ip char(8) NOT NULL default '',
  rate_time int(10) unsigned NOT NULL default '1026766723',
  PRIMARY KEY  (user_id,topic_id)
) TYPE=MyISAM;

DROP TABLE IF EXISTS shoutbox;
DROP TABLE IF EXISTS chatsession;
DROP TABLE IF EXISTS phpbb_calendar;
#---ø
CREATE TABLE phpbb_chatbox (
	id int(11) NOT NULL auto_increment,
	name varchar(99) NOT NULL,
	msg varchar(255) NOT NULL,
	timestamp int(10) unsigned NOT NULL,
	PRIMARY KEY (id));

CREATE TABLE phpbb_chatbox_session (
	username varchar(99) NOT NULL,
	lastactive int(10) DEFAULT '0' NOT NULL,
	laststatus varchar(8) NOT NULL,
	UNIQUE username (username)
);

#--- 
CREATE TABLE phpbb_favorite_folder (
  folder_id mediumint(8) NOT NULL auto_increment,
  folder_name varchar(25) NOT NULL default '',
  owner_id mediumint(8) NOT NULL default '0',
  collections mediumint(8) NOT NULL default '0',
  create_time int(11) default NULL,
  PRIMARY KEY  (folder_id)
);

CREATE TABLE phpbb_favorites (
  favorite_id mediumint(8) NOT NULL auto_increment,
  topic_id mediumint(8) NOT NULL default '0',
  folder_id mediumint(8) NOT NULL default '0',
  user_id mediumint(8) NOT NULL default '0',
  add_time int(11) NOT NULL default '0',
  PRIMARY KEY  (favorite_id)
);

#--- 轺Ű
CREATE TABLE phpbb_stats_config (
  config_name varchar(50) NOT NULL default '',
  config_value varchar(255) NOT NULL default '',
  PRIMARY KEY (config_name)
);

CREATE TABLE phpbb_stats_modules (
  module_id tinyint(8) NOT NULL default '0',
  name varchar(150) NOT NULL default '',
  active tinyint(1) NOT NULL default '0',
  installed tinyint(1) NOT NULL default '0',
  display_order mediumint(8) unsigned NOT NULL default '0',
  update_time mediumint(8) unsigned NOT NULL default '0',
  auth_value tinyint(2) NOT NULL default '0',
  module_info_cache blob,
  module_data_cache blob,
  module_info_time int(10) unsigned NOT NULL default '0',
  module_data_time int(10) unsigned NOT NULL default '0',
  PRIMARY KEY (module_id)
);

#--- αī
CREATE TABLE phpbb_counter_log (
  counter_id int(11) NOT NULL auto_increment,
  user_id mediumint(8) NOT NULL default '0',
  username varchar(25) NOT NULL default '0',
  counter_time int NOT NULL default '',
  counter_ip varchar(15) NOT NULL default '',
  browser varchar(64) NOT NULL default '0',
  counter_referer varchar(250) NOT NULL default '',
  PRIMARY KEY  (counter_id),
  KEY counter_time (counter_time)
) TYPE=MyISAM;

CREATE TABLE phpbb_out_log (
 no int(8) unsigned default '0' auto_increment,
 user_id mediumint(8) not null,
 username varchar(25) not null,
 user_regdate int(11) not null,
 out_log text,
 time int(10) unsigned,
 PRIMARY KEY (no)
);

CREATE TABLE phpbb_buddies (
 user_id mediumint(8) NOT NULL, 
 buddy_id mediumint(8) NOT NULL
);
