<?php
/***************************************************************************
 *                               functions.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: functions.php,v 1.133.2.5 2002/07/08 10:30:41 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/
### ڿ ڸ
function str_cut($str, $len, $suffix){ 
   if ($len >= strlen($str)) return $str; 

   $klen = $len - 1; 

   while(ord($str[$klen]) & 0x80) $klen--; 

   return substr($str, 0, $len - (($len + $klen + 1) % 2)) . $suffix; 
}

function msg($message,$url="back") {
	echo "<script>window.alert('$message');";
    if ($url == "back") { echo "history.back()"; }
    else { echo "location.href='$url'"; }
    echo "</script>";
	exit;
    }

function get_db_stat($mode)
{
	global $db;

	switch( $mode )
	{
		case 'usercount':
			$sql = "SELECT COUNT(user_id) AS total
				FROM " . USERS_TABLE . "
				WHERE user_id <> " . ANONYMOUS;
			break;

		case 'newestuser':
			$sql = "SELECT user_id, username
				FROM " . USERS_TABLE . "
				WHERE user_id <> " . ANONYMOUS . "
				ORDER BY user_id DESC
				LIMIT 1";
			break;

		case 'postcount':
		case 'topiccount':
			// DJ-Begin, 5.4.02
			$sql = "SELECT SUM(forum_topics) AS topic_total, SUM(forum_posts) AS post_total
				FROM " . FORUMS_TABLE . "
				WHERE forum_issub = " . FORUM_ISNOSUB;
			// DJ-End, 5.4.02
	}

	if ( !($result = $db->sql_query($sql)) )
	{
		return false;
	}

	$row = $db->sql_fetchrow($result);

	switch ( $mode )
	{
		case 'usercount':
			return $row['total'];
			break;
		case 'newestuser':
			return $row;
			break;
		case 'postcount':
			return $row['post_total'];
			break;
		case 'topiccount':
			return $row['topic_total'];
			break;
	}

	return false;
}

function get_userdata($user)
{
	global $db;

	$sql = "SELECT *
		FROM " . USERS_TABLE . " 
		WHERE ";
	$sql .= ( ( is_integer($user) ) ? "user_id = $user" : "username = '" .  str_replace("\'", "''", $user) . "'" ) . " AND user_id <> " . ANONYMOUS;
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Tried obtaining data for a non-existent user', '', __LINE__, __FILE__, $sql);
	}

	return ( $row = $db->sql_fetchrow($result) ) ? $row : false;
}

function make_jumpbox($action, $match_forum_id = 0)
{
	// DJ-Begin, 23.3.02
	global $lang, $db, $SID, $nav_links, $template;

//	$is_auth = auth(AUTH_VIEW, AUTH_LIST_ALL, $userdata);

	$sql = "SELECT c.cat_id, c.cat_title, c.cat_order, c.parent_forum_id, c.cat_hier_level
		FROM " . CATEGORIES_TABLE . " c, " . FORUMS_TABLE . " f
		WHERE f.cat_id = c.cat_id
		GROUP BY c.cat_id, c.cat_title, c.cat_order
		ORDER BY c.cat_order";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't obtain category list.", "", __LINE__, __FILE__, $sql);
	}
	
	$category_rows = array();
	while ( $row = $db->sql_fetchrow($result) )
	{
		$category_rows[] = $row;
	}
	
	if ( $total_categories = count($category_rows) )
	{
		$sql = "SELECT *
			FROM " . FORUMS_TABLE . "
			ORDER BY cat_id, forum_order";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain forums information', '', __LINE__, __FILE__, $sql);
		}

		$boxstring = "\n\n" . '<select name="' . POST_FORUM_URL . '" onChange="if(this.options[this.selectedIndex].value != -1) {window.location.href = this.options[this.selectedIndex].value;}"><option value="-1">' . $lang['Select_forum'] . '</option>';
																					 
		$forum_rows = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$forum_rows[] = $row;
		}

		if ( $total_forums = count($forum_rows) )
		{
			$boxstring .= recursive_jumpbox($category_rows, $forum_rows, $total_categories, $total_forums, $match_forum_id, 0, 0);
		}

		$boxstring .= '</select>';
	}
	else
	{
		$boxstring = "\n\n" . '<select name="' . POST_FORUM_URL . '" onChange="if(this.options[this.selectedIndex].value != -1) {window.location.href = this.options[this.selectedIndex].value;}"><option value="-1"></option>';
	}
	// DJ-End, 23.3.02


	if ( isset($SID) )
	{
		$boxstring .= '<input type="hidden" name="sid" value="' . $SID . '" />';
	}

	$template->set_filenames(array(
		'jumpbox' => 'jumpbox.tpl')
	);
	$template->assign_vars(array(
		'L_GO' => $lang['Go'],
		'L_JUMP_TO' => $lang['Jump_to'],
		'L_SELECT_FORUM' => $lang['Select_forum'],

		'S_JUMPBOX_SELECT' => $boxstring,
		'S_JUMPBOX_ACTION' => append_sid($action))
	);
	$template->assign_var_from_handle('JUMPBOX', 'jumpbox');

	return;
}

// DJ-Begin, 23.3.02, 23.4.02
// Going recursively through the hierarchie and creating a list 
function recursive_jumpbox(&$category_rows, &$forum_rows, &$total_categories, &$total_forums, &$match_forum_id, $current_hierarchie, $parent_forum_id)
{
	global $phpEx;

	for($i = 0; $i < $total_categories; $i++)
	{
    if ( $category_rows[$i]['cat_hier_level'] != $current_hierarchie 
			|| $category_rows[$i]['parent_forum_id'] != $parent_forum_id )
			continue;
		$boxstring_forums = '';

		$class = 'h' . ($current_hierarchie%3);

		for($j = 0; $j < $total_forums; $j++)
		{
			if ( $forum_rows[$j]['cat_id'] == $category_rows[$i]['cat_id']
				&& $forum_rows[$j]['auth_view'] <= AUTH_REG 
				&& $forum_rows[$j]['forum_hier_level'] == $current_hierarchie )
			{
				$selected = ( $forum_rows[$j]['forum_id'] == $match_forum_id ) ? 'selected="selected"' : '';

				if ( $forum_rows[$j]['forum_issub'] == FORUM_ISNOSUB)
				{
					$boxstring_forums .= '<option value="' .
						append_sid("viewforum.$phpEx?" . POST_FORUM_URL . '=' . $forum_rows[$j]['forum_id']) .
						'" class="' . $class . '"' . $selected . '>' .
						space($forum_rows[$j]['forum_hier_level']*2, '&nbsp;') . "- " . $forum_rows[$j]['forum_name'] .
						'</option>' . "\n";
				}
				else
				{
					$boxstring_forums .=
						'<option value="' . 
						append_sid("index.$phpEx?" . POST_HIERARCHIE_URL . "=" . ($forum_rows[$j]['forum_hier_level']+1) . "&" . POST_PARENTFORUM_URL . "=" . $forum_rows[$j]['forum_id']) .
						'" class="' . $class . 'sf" '. $selected . '>' .
						space($forum_rows[$j]['forum_hier_level']*2, '&nbsp;') . "* " . $forum_rows[$j]['forum_name'] .
						'</option>' . "";
					$boxstring_forums .= recursive_jumpbox($category_rows, $forum_rows, $total_categories, $total_forums, $match_forum_id, $current_hierarchie+1, $forum_rows[$j]['forum_id']);

				}
			}
		}

		if ( $boxstring_forums != '' )
		{

			$boxstring .= '<option value="-1" class="' . $class . 'c">' . space($category_rows[$i]['cat_hier_level']*1, '&nbsp; +&nbsp;') . $category_rows[$i]['cat_title']  . '</option>' . "\n"\;
			$boxstring .= '<option value="-1" class="' . $class . 'c">' . space($category_rows[$i]['cat_hier_level']*2, '&nbsp;') . space(strlen($category_rows[$i]['cat_title'])*1.2, '-') . '</option>' . "\n";
			//$boxstring .= '<option value="-1">' . space($category_rows[$i]['cat_hier_level']*2, '&nbsp;') . '________________</option>' . "\n";
			$boxstring .= $boxstring_forums;
		}
	}
	return $boxstring;
}
// DJ-End, 23.3.02, 23.4.02

//
// DJ-Begin, 23.3.02
// returns a string of $number length containing only $string
function space($number = 1, $string = " ")
{
  $spaces = "";
  for($i=0;$i<$number;$i++)
	{
		$spaces .= $string;
	}
  return $spaces;
}
// DJ-End, 23.3.02

//
// Initialise user settings on page load
function init_userprefs($userdata)
{
	global $board_config, $theme, $images;
	global $template, $lang, $phpEx, $phpbb_root_path;

	if ( $userdata['user_id'] != ANONYMOUS )
	{
		if ( !empty($userdata['user_lang']))
		{
			$board_config['default_lang'] = $userdata['user_lang'];
		}

		if ( !empty($userdata['user_dateformat']) )
		{
			$board_config['default_dateformat'] = $userdata['user_dateformat'];
		}

		if ( isset($userdata['user_timezone']) )
		{
			$board_config['board_timezone'] = $userdata['user_timezone'];
		}
	}

	if ( !file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_main.'.$phpEx) )
	{
		$board_config['default_lang'] = 'english';
	}

	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_main.' . $phpEx);

	if ( defined('IN_ADMIN') )
	{
		if( !file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.'.$phpEx) )
		{
			$board_config['default_lang'] = 'english';
		}

		include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.' . $phpEx);
	}

	include_attach_lang();
	//
	// Set up style
	//
	if ( !$board_config['override_user_style'] )
	{
		if ( $userdata['user_id'] != ANONYMOUS && $userdata['user_style'] > 0 )
		{
			if ( $theme = setup_style($userdata['user_style']) )
			{
				return;
			}
		}
	}

	$theme = setup_style($board_config['default_style']);

	return;
}

function setup_style($style)
{
	global $db, $board_config, $template, $images, $phpbb_root_path;

	$sql = "SELECT *
		FROM " . THEMES_TABLE . "
		WHERE themes_id = $style";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(CRITICAL_ERROR, 'Could not query database for theme info');
	}

	if ( !($row = $db->sql_fetchrow($result)) )
	{
		message_die(CRITICAL_ERROR, "Could not get theme data for themes_id [$style]");
	}

	$template_path = 'templates/' ;
	$template_name = $row['template_name'] ;

	$template = new Template($phpbb_root_path . $template_path . $template_name, $board_config, $db);

	if ( $template )
	{
		$current_template_path = $template_path . $template_name;
		@include($phpbb_root_path . $template_path . $template_name . '/' . $template_name . '.cfg');

		if ( !defined('TEMPLATE_CONFIG') )
		{
			message_die(CRITICAL_ERROR, "Could not open $template_name template config file", '', __LINE__, __FILE__);
		}

		$img_lang = ( file_exists($current_template_path . '/images/lang_' . $board_config['default_lang']) ) ? $board_config['default_lang'] : 'english';

		while( list($key, $value) = @each($images) )
		{
			if ( !is_array($value) )
			{
				$images[$key] = str_replace('{LANG}', 'lang_' . $img_lang, $value);
			}
		}
	}

	return $row;
}

function encode_ip($dotquad_ip)
{
	$ip_sep = explode('.', $dotquad_ip);
	return sprintf('%02x%02x%02x%02x', $ip_sep[0], $ip_sep[1], $ip_sep[2], $ip_sep[3]);
}

function decode_ip($int_ip)
{
	$hexipbang = explode('.', chunk_split($int_ip, 2, '.'));
	return hexdec($hexipbang[0]). '.' . hexdec($hexipbang[1]) . '.' . hexdec($hexipbang[2]) . '.' . hexdec($hexipbang[3]);
}

// decode mysql-timestamps 
// 
function mysql_timestamp_to_timestamp($dt) 
{ 
                $yr=strval(substr($dt,0,4)); 
                $mo=strval(substr($dt,4,2)); 
                $da=strval(substr($dt,6,2)); 
                $hr=strval(substr($dt,8,2)); 
                $mi=strval(substr($dt,10,2)); 
                $se=strval(substr($dt,10,2)); 

                return mktime($hr,$mi,$se,$mo,$da,$yr); 
} 

//
// Create date/time from format and timezone
//
function create_date($format, $gmepoch, $tz)
{
	global $board_config, $lang;
	static $translate;

	if ( empty($translate) && $board_config['default_lang'] != 'english' )
	{
		@reset($lang['datetime']);
		while ( list($match, $replace) = @each($lang['datetime']) )
		{
			$translate[$match] = $replace;
		}
	}

	return ( !empty($translate) ) ? strtr(@gmdate($format, $gmepoch + (3600 * $tz)), $translate) : @gmdate($format, $gmepoch + (3600 * $tz));
}

//
// Pagination routine, generates
// page number sequence
//
function generate_pagination($base_url, $num_items, $per_page, $start_item, $add_prevnext_text = TRUE)
{
	global $lang;

	$total_pages = ceil($num_items/$per_page);

	if ( $total_pages == 1 )
	{
		return '';
	}

	$on_page = floor($start_item / $per_page) + 1;

	$page_string = '';
	if ( $total_pages > 10 )
	{
		$init_page_max = ( $total_pages > 3 ) ? 3 : $total_pages;

		for($i = 1; $i < $init_page_max + 1; $i++)
		{
			$page_string .= ( $i == $on_page ) ? '<b>' . $i . '</b>' : '<a href="' . append_sid($base_url . "&amp;start=" . ( ( $i - 1 ) * $per_page ) ) . '">' . $i . '</a>';
			if ( $i <  $init_page_max )
			{
				$page_string .= ", ";
			}
		}

		if ( $total_pages > 3 )
		{
			if ( $on_page > 1  && $on_page < $total_pages )
			{
				$page_string .= ( $on_page > 5 ) ? ' ... ' : ', ';

				$init_page_min = ( $on_page > 4 ) ? $on_page : 5;
				$init_page_max = ( $on_page < $total_pages - 4 ) ? $on_page : $total_pages - 4;

				for($i = $init_page_min - 1; $i < $init_page_max + 2; $i++)
				{
					$page_string .= ($i == $on_page) ? '<b>' . $i . '</b>' : '<a href="' . append_sid($base_url . "&amp;start=" . ( ( $i - 1 ) * $per_page ) ) . '">' . $i . '</a>';
					if ( $i <  $init_page_max + 1 )
					{
						$page_string .= ', ';
					}
				}

				$page_string .= ( $on_page < $total_pages - 4 ) ? ' ... ' : ', ';
			}
			else
			{
				$page_string .= ' ... ';
			}

			for($i = $total_pages - 2; $i < $total_pages + 1; $i++)
			{
				$page_string .= ( $i == $on_page ) ? '<b>' . $i . '</b>'  : '<a href="' . append_sid($base_url . "&amp;start=" . ( ( $i - 1 ) * $per_page ) ) . '">' . $i . '</a>';
				if( $i <  $total_pages )
				{
					$page_string .= ", ";
				}
			}
		}
	}
	else
	{
		for($i = 1; $i < $total_pages + 1; $i++)
		{
			$page_string .= ( $i == $on_page ) ? '<b>' . $i . '</b>' : '<a href="' . append_sid($base_url . "&amp;start=" . ( ( $i - 1 ) * $per_page ) ) . '">' . $i . '</a>';
			if ( $i <  $total_pages )
			{
				$page_string .= ', ';
			}
		}
	}

	if ( $add_prevnext_text )
	{
		if ( $on_page > 1 )
		{
			$page_string = ' <a href="' . append_sid($base_url . "&amp;start=" . ( ( $on_page - 2 ) * $per_page ) ) . '">' . $lang['Previous'] . '</a>&nbsp;&nbsp;' . $page_string;
		}

		if ( $on_page < $total_pages )
		{
			$page_string .= '&nbsp;&nbsp;<a href="' . append_sid($base_url . "&amp;start=" . ( $on_page * $per_page ) ) . '">' . $lang['Next'] . '</a>';
		}

	}

	$page_string = $lang['Goto_page'] . ' ' . $page_string;

	return $page_string;
}

//
// This does exactly what preg_quote() does in PHP 4-ish
// If you just need the 1-parameter preg_quote call, then don't bother using this.
//
function phpbb_preg_quote($str, $delimiter)
{
	$text = preg_quote($str);
	$text = str_replace($delimiter, '\\' . $delimiter, $text);
	
	return $text;
}

//
// Obtain list of naughty words and build preg style replacement arrays for use by the
// calling script, note that the vars are passed as references this just makes it easier
// to return both sets of arrays
//
function obtain_word_list(&$orig_word, &$replacement_word)
{
	global $db;

	//
	// Define censored word matches
	//
	$sql = "SELECT word, replacement
		FROM  " . WORDS_TABLE;
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not get censored words from database', '', __LINE__, __FILE__, $sql);
	}

	if ( $row = $db->sql_fetchrow($result) )
	{
		do 
		{
			$orig_word[] = '#\b(' . str_replace('\*', '\w*?', phpbb_preg_quote($row['word'], '#')) . ')\b#i';
			$replacement_word[] = $row['replacement'];
		}
		while ( $row = $db->sql_fetchrow($result) );
	}

	return true;
}

//
// This is general replacement for die(), allows templated
// output in users (or default) language, etc.
//
// $msg_code can be one of these constants:
//
// GENERAL_MESSAGE : Use for any simple text message, eg. results 
// of an operation, authorisation failures, etc.
//
// GENERAL ERROR : Use for any error which occurs _AFTER_ the 
// common.php include and session code, ie. most errors in 
// pages/functions
//
// CRITICAL_MESSAGE : Used when basic config data is available but 
// a session may not exist, eg. banned users
//
// CRITICAL_ERROR : Used when config data cannot be obtained, eg
// no database connection. Should _not_ be used in 99.5% of cases
//
function message_die($msg_code, $msg_text = '', $msg_title = '', $err_line = '', $err_file = '', $sql = '')
{
	global $db, $template, $board_config, $theme, $lang, $phpEx, $phpbb_root_path, $nav_links, $gen_simple_header;
	global $userdata, $user_ip, $session_length;
	global $starttime;

	$sql_store = $sql;
	
	//
	// Get SQL error if we are debugging. Do this as soon as possible to prevent 
	// subsequent queries from overwriting the status of sql_error()
	//
	if ( DEBUG && ( $msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR ) )
	{
		$sql_error = $db->sql_error();

		$debug_text = '';

		if ( $sql_error['message'] != '' )
		{
			$debug_text .= '<br /><br />SQL Error : ' . $sql_error['code'] . ' ' . $sql_error['message'];
		}

		if ( $sql_store != '' )
		{
			$debug_text .= "<br /><br />$sql_store";
		}

		if ( $err_line != '' && $err_file != '' )
		{
			$debug_text .= '</br /><br />Line : ' . $err_line . '<br />File : ' . $err_file;
		}
	}

	if( empty($userdata) && ( $msg_code == GENERAL_MESSAGE || $msg_code == GENERAL_ERROR ) )
	{
		$userdata = session_pagestart($user_ip, PAGE_INDEX);
		init_userprefs($userdata);
	}

	//
	// If the header hasn't been output then do it
	//
	if ( !defined('HEADER_INC') && $msg_code != CRITICAL_ERROR )
	{
		if ( empty($lang) )
		{
			if ( !empty($board_config['default_lang']) )
			{
				include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_main.'.$phpEx);
			}
			else
			{
				include($phpbb_root_path . 'language/lang_english/lang_main.'.$phpEx);
			}
		}

		if ( empty($template) )
		{
			$template = new Template($phpbb_root_path . 'templates/' . $board_config['board_template']);
		}
		if ( empty($theme) )
		{
			$theme = setup_style($board_config['default_style']);
		}

		//
		// Load the Page Header
		//
		if ( !defined('IN_ADMIN') )
		{
			include($phpbb_root_path . 'includes/page_header.'.$phpEx);
		}
		else
		{
			include($phpbb_root_path . 'admin/page_header_admin.'.$phpEx);
		}
	}

	switch($msg_code)
	{
		case GENERAL_MESSAGE:
			if ( $msg_title == '' )
			{
				$msg_title = $lang['Information'];
			}
			break;

		case CRITICAL_MESSAGE:
			if ( $msg_title == '' )
			{
				$msg_title = $lang['Critical_Information'];
			}
			break;

		case GENERAL_ERROR:
			if ( $msg_text == '' )
			{
				$msg_text = $lang['An_error_occured'];
			}

			if ( $msg_title == '' )
			{
				$msg_title = $lang['General_Error'];
			}
			break;

		case CRITICAL_ERROR:
			//
			// Critical errors mean we cannot rely on _ANY_ DB information being
			// available so we're going to dump out a simple echo'd statement
			//
			include($phpbb_root_path . 'language/lang_english/lang_main.'.$phpEx);

			if ( $msg_text == '' )
			{
				$msg_text = $lang['A_critical_error'];
			}

			if ( $msg_title == '' )
			{
				$msg_title = 'phpBB : <b>' . $lang['Critical_Error'] . '</b>';
			}
			break;
	}

	//
	// Add on DEBUG info if we've enabled debug mode and this is an error. This
	// prevents debug info being output for general messages should DEBUG be
	// set TRUE by accident (preventing confusion for the end user!)
	//
	if ( DEBUG && ( $msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR ) )
	{
		if ( $debug_text != '' )
		{
			$msg_text = $msg_text . '<br /><br /><b><u>DEBUG MODE</u></b>' . $debug_text;
		}
	}

	if ( $msg_code != CRITICAL_ERROR )
	{
		if ( !empty($lang[$msg_text]) )
		{
			$msg_text = $lang[$msg_text];
		}

		if ( !defined('IN_ADMIN') )
		{
			$template->set_filenames(array(
				'message_body' => 'message_body.tpl')
			);
		}
		else
		{
			$template->set_filenames(array(
				'message_body' => 'admin/admin_message_body.tpl')
			);
		}

		$template->assign_vars(array(
			'MESSAGE_TITLE' => $msg_title,
			'MESSAGE_TEXT' => $msg_text)
		);
		$template->pparse('message_body');

		if ( !defined('IN_ADMIN') )
		{
			include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		}
		else
		{
			include($phpbb_root_path . 'admin/page_footer_admin.'.$phpEx);
		}
	}
	else
	{
		echo "<html>\n<body>\n" . $msg_title . "\n<br /><br />\n" . $msg_text . "</body>\n</html>";
	}

	exit;
}

// Add function mkrealdate for Birthday MOD 
// the originate php "mktime()", does not work proberly on all OS, especially when going back in time 
// before year 1970 (year 0), this function "mkrealtime()", has a mutch larger valid date range, 
// from 1901 - 2099. it returns a "like" UNIX timestamp divided by 86400, so 
// calculation from the originate php date and mktime is easy. 
// mkrealdate, returns the number of day (with sign) from 1.1.1970. 

function mkrealdate($day,$month,$year) 
{ 
   // range check months 
   if ($month<1 || $month>12) return "error"; 
   // range check days 
   switch ($month) 
   { 
      case 1: if ($day>31) return "error";break; 
      case 2: if ($day>29) return "error"; 
         $epoch=$epoch+31;break; 
      case 3: if ($day>31) return "error"; 
         $epoch=$epoch+59;break; 
      case 4: if ($day>30) return "error" ; 
         $epoch=$epoch+90;break; 
      case 5: if ($day>31) return "error"; 
         $epoch=$epoch+120;break; 
      case 6: if ($day>30) return "error"; 
         $epoch=$epoch+151;break; 
      case 7: if ($day>31) return "error"; 
         $epoch=$epoch+181;break; 
      case 8: if ($day>31) return "error"; 
         $epoch=$epoch+212;break; 
      case 9: if ($day>30) return "error"; 
         $epoch=$epoch+243;break; 
      case 10: if ($day>31) return "error"; 
         $epoch=$epoch+273;break; 
      case 11: if ($day>30) return "error"; 
         $epoch=$epoch+304;break; 
      case 12: if ($day>31) return "error"; 
         $epoch=$epoch+334;break; 
   } 
   $epoch=$epoch+$day; 
   $epoch_Y=sqrt(($year-1970)*($year-1970)); 
   $leapyear=round((($epoch_Y+2) / 4)-.5); 
   if (($epoch_Y+2)%4==0) 
   {// curent year is leapyear 
      $leapyear--; 
      if ($year >1970 && $month>=3) $epoch=$epoch+1; 
      if ($year <1970 && $month<3) $epoch=$epoch-1; 
   } else if ($month==2 && $day>28) return "error";//only 28 days in feb. 
   //year 
   if ($year>1970) 
      $epoch=$epoch+$epoch_Y*365-1+$leapyear; 
   else 
      $epoch=$epoch-$epoch_Y*365-1-$leapyear; 
   return $epoch; 
} 

// Add function realdate for Birthday MOD 
// the originate php "date()", does not work proberly on all OS, especially when going back in time 
// before year 1970 (year 0), this function "realdate()", has a mutch larger valid date range, 
// from 1901 - 2099. it returns a "like" UNIX date format (only d,m and Y, may be used) 
// is expect a input like a UNIX timestamp divided by 86400, so 
// calculation from the originate php date and mktime is easy. 
// e.g. realdate ("m d Y", 3) returns the string "1 3 1970" 

function realdate($date_syntax,$date) 
{ 
   global $lang; 
   $year=0; 
   $date_mid=$date; 
   $i=2; 
   if ($date>=0) 
   { 
      while ($date_mid>364) 
      { 
         $date_mid=$date_mid-365; 
         $year++; 
         if ($i==3) 
         { 
            $i=0; 
            if ($date_mid>365) 
            { 
               $date_mid--; 
            } 
         } else $i++; 
      } 
   } else if ($date<0) 
   { 
      while ($date_mid<0) 
      { 
         $year--; 
         $date_mid=$date_mid+365; 
         if ($i==3) 
         { 
            $i=0; 
            $date_mid++; 
         } else $i++; 
      } 
   } 
   $days=$days+$date_mid; 
   if (($year+2)%4==0) 
   { 
      if ($date_mid>334) 
      { 
         $day=$date_mid-334; 
         $month=12; 
      } else if ($date_mid>304) 
      { 
         $day=$date_mid-304; 
         $month=11; 
      } else if ($date_mid>273) 
      { 
         $day=$date_mid-273; 
         $month=10; 
      } else if ($date_mid>243) 
      { 
         $day=$date_mid-243; 
         $month=9; 
      } else if ($date_mid>212) 
      { 
         $day=$date_mid-212; 
         $month=8; 
      } else if ($date_mid>181) 
      { 
         $day=$date_mid-181; 
         $month=7; 
      } else if ($date_mid>151) 
      { 
         $day=$date_mid-151; 
         $month=6; 
      } else if ($date_mid>120) 
      { 
         $day=$date_mid-120; 
         $month=5; 
      } else if ($date_mid>90) 
      { 
         $day=$date_mid-90; 
         $month=4; 
      } else if ($date_mid>59) 
      { 
         $day=$date_mid-59; 
         $month=3; 
      } else if ($date_mid>30) 
      { 
         $day=$date_mid-30; 
         $month=2; 
      } else 
      { 
         $month=1; 
         $day=$date_mid+1; 
      } 
   } else 
   { 
      if ($date_mid>333) 
      { 
         $day=$date_mid-333; 
         $month=12; 
      } else if ($date_mid>303) 
      { 
         $day=$date_mid-303; 
         $month=11; 
      } else if ($date_mid>272) 
      { 
         $day=$date_mid-272; 
         $month=10; 
      } else if ($date_mid>242) 
      { 
         $day=$date_mid-242; 
         $month=9; 
      } else if ($date_mid>211) 
      { 
         $day=$date_mid-211; 
         $month=8; 
      } else if ($date_mid>180) 
      { 
         $day=$date_mid-180; 
         $month=7; 
      } else if ($date_mid>150) 
      { 
         $day=$date_mid-150; 
         $month=6; 
      } else if ($date_mid>119) 
      { 
         $day=$date_mid-119; 
         $month=5; 
      } else if ($date_mid>89) 
      { 
         $day=$date_mid-89; 
         $month=4; 
      } else if ($date_mid>58) 
      { 
         $day=$date_mid-58; 
         $month=3; 
      } else if ($date_mid>30) 
      { 
         $day=$date_mid-30; 
         $month=2; 
      } else 
      { 
         $month=1; 
         $day=$date_mid+1; 
      } 
   } 
if (!(strrpos($date_syntax, "j") ===false)) 
$date_syntax = str_replace('j',$day,$date_syntax); 
else 
{ 
if ($day<10)$day='0'.($day); 
$date_syntax = str_replace('d',$day,$date_syntax); 
} 
if (!(strrpos($date_syntax, "n") ===false)) 
$date_syntax = str_replace('n',$month,$date_syntax); 
else 
{ 
if ($month<10)$month='0'.($month); 
$date_syntax = str_replace('m',$month,$date_syntax); 
$month--; 
$date_table = array ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'); 
$date_syntax = str_replace('M',$lang['datetime'][$date_table[$month]],$date_syntax); 
} 
$year=$year+1970; 
$date_syntax = str_replace('Y',$year,$date_syntax); 

   return $date_syntax; 
} 
?>