<?php
/***************************************************************************
*                           functions_stats.php
*                            -------------------
*   begin                : Wed, Sep 04, 2002
*   copyright            : (C) 2002 Meik Sievertsen
*   email                : acyd.burn@gmx.de
*
*   $Id: functions_stats.php,v 2.1.0 2002/09/04 acyd_burn Exp $
*
*
***************************************************************************/

/***************************************************************************
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
***************************************************************************/


function get_module_info($module_id)
{
	global $db, $phpbb_root_path, $stats_config;

	$sql = "SELECT name, update_time, auth_value, active, module_info_time, module_info_cache
	FROM " . MODULES_TABLE . "
	WHERE module_id = " . $module_id;

	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
	}

	$row = $db->sql_fetchrow($result);
	
	$module_dir = trim($row['name']);
	//
	// Get Info from Cache or not...
	//
	if ($row['module_info_time'] == filemtime($phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_dir . '/info.txt'))
	{
		$ret_array = unserialize(stripslashes($row['module_info_cache']));
	}
	else
	{
		$extra_info_mode = FALSE;
		$data_file = @file($phpbb_root_path . trim($stats_config['modules_dir']) . '/' . $module_dir . '/info.txt');
		
		while (list($key, $data) = @each($data_file))
		{
			if (!$extra_info_mode)
			{
				if (preg_match("/\[name\]/", $data))
				{
					$ret_array['name'] = trim(str_replace("[name]", '', $data));
				}
				elseif (preg_match("/\[author\]/", $data))
				{
					$ret_array['author'] = trim(str_replace("[author]", '', $data));
				}
				elseif (preg_match("/\[email\]/", $data))
				{
					$ret_array['email'] = trim(str_replace("[email]", '', $data));
				}
				elseif (preg_match("/\[url\]/", $data))
				{
					$ret_array['url'] = trim(str_replace("[url]", '', $data));
				}
				elseif (preg_match("/\[version\]/", $data))
				{
					$ret_array['version'] = trim(str_replace("[version]", '', $data));
				}
				elseif (preg_match("/\[extra_info\]/", $data))
				{
					$extra_info_mode = TRUE;
					$ret_array['extra_info'] =  trim(str_replace("[extra_info]", '', $data));
				}
			}
			else
			{
				$ret_array['extra_info'] .=  $data;
			}
		}

		$sql = "UPDATE " . MODULES_TABLE . "
		SET module_info_cache = '" . addslashes(serialize($ret_array)) . "',
		module_info_time = " . filemtime($phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_dir . '/info.txt') . "
		WHERE module_id = " . $module_id;

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}
		
	}
	
	$ret_array['dname'] = $module_dir;
	$ret_array['update_time'] = $row['update_time'];
	$ret_array['auth_value'] = $row['auth_value'];
	$ret_array['active'] = $row['active'];
	return $ret_array;
}

//
// Get and update Module List
//
function update_module_list()
{
	global $phpbb_root_path, $db, $stats_config;

	//
	// Returns a list of modules found by directory and updates the database as needed
	//
	$ret_list = array();
	
	$handle = @opendir($phpbb_root_path . $stats_config['modules_dir']);

	if (!$handle)
	{
		message_die(GENERAL_ERROR, "Unable to open directory " . $phpbb_root_path . $stats_config['modules_dir']);
	}

	$dir_list = '';
	
	while ($file = readdir($handle))
	{
		if ($file != '.' && $file != '..' && is_dir($phpbb_root_path . $stats_config['modules_dir'] . '/' . $file))
		{
			$dir_list .= ($dir_list == '') ? "'$file'" : ", '$file'";
			
			$sql = "SELECT MAX(display_order) as max
			FROM " . MODULES_TABLE;

			if (!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
			}

			$row = $db->sql_fetchrow($result);
			
			$curr_max = $row['max'];
			
			$sql = "SELECT module_id, name, display_order, active
			FROM " . MODULES_TABLE . "
			WHERE (name = '" . trim($file) . "')";

			if (!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
			}

			if ($db->sql_numrows($result) == 0)
			{
				$sql = "SELECT MAX(module_id) as next_id FROM " . MODULES_TABLE;

				if (!($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
				}
				
				$row = $db->sql_fetchrow($result);
				$next_id = $row['next_id'] + 1;
			    
				$sql = "INSERT INTO  " . MODULES_TABLE . "
				(module_id, name, display_order)
				VALUES (" . $next_id . ", '" . trim($file) . "', " . ($curr_max + 10) . ")";

				if (!$db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
				}
				
				$sql = "SELECT module_id, display_order, active
				FROM " . MODULES_TABLE . "
				WHERE module_id = " . $next_id;
				
				if (!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
				}

				$row = $db->sql_fetchrow($result);
			}
			else
			{
				$row = $db->sql_fetchrow($result);
			}

		}
	}

	//
	// Kill old module folders that were deleted
	//
	$sql = "DELETE FROM " . MODULES_TABLE . "
	WHERE (name NOT IN ($dir_list))";

	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
	}
}

function get_module_list_from_db()
{
	global $phpbb_root_path, $db, $stats_config;

	//
	// Returns a list of modules stored in the database
	//
	$ret_list = array();
	
	$sql = "SELECT module_id, name, display_order
	FROM " . MODULES_TABLE . "
	WHERE (active = 1) AND (installed = 1)
	ORDER BY display_order ASC";

	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
	}

	if ($db->sql_numrows($result) != 0)
	{
		$rows = $db->sql_fetchrowset($result);

		for ($i = 0; $i < count($rows); $i++)
		{
			$ret_list[$rows[$i]['module_id']] = $rows[$i]['name'];
		}
	}

	return ($ret_list);
}

function module_auth_check($module_id, $userdata)
{
	// FALSE = Not Authorized
	// TRUE = Authorized
	global $db;

	$sql = "SELECT auth_value
	FROM " . MODULES_TABLE . "
	WHERE module_id = " . $module_id;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Failed obtaining module access control lists', '', __LINE__, __FILE__, $sql);
	}

	if ( !($row = $db->sql_fetchrow($result)) )
	{
		message_die(GENERAL_ERROR, 'No module access control lists exist', '', __LINE__, __FILE__, $sql);
	}

	$db->sql_freeresult($result);

	switch ($row['auth_value'])
	{
		case AUTH_ALL:
			return (true);
			break;

		case AUTH_REG:
			if ( ($userdata['session_logged_in']) && ($userdata['user_id'] != ANONYMOUS) )
			{
				return (true);
			}
			else
			{
				return (false);
			}
			break;

		case AUTH_ADMIN:
			if ( ( $userdata['user_level'] == ADMIN && $userdata['session_logged_in'] ) )
			{
				return (true);
			}
			else
			{
				return (false);
			}
			break;
	}

	return (false);
}

?>