<?php
		/***************************************************************************
								rate_functions.php
		                             -------------------
		    begin                : Sat Feb 23, 2002
		    copyright            : (C) 2002 Nivisec.com
		    email                : nivisec@hotmail.com
		
		    		$Id: rate_functions.php,v 1.2.2 2002/04/21 00:00:00 nivisec Exp $
		
		 ***************************************************************************/
		
		/***************************************************************************
		 *                                         				                                
		 *   This program is free software; you can redistribute it and/or modify  	
		 *   it under the terms of the GNU General Public License as published by  
		 *   the Free Software Foundation; either version 2 of the License, or	    	
		 *   (at your option) any later version.
		 *
		 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

$topic_id = $HTTP_POST_VARS['topic_id']; 
if(!$topic_id) $topic_id = $HTTP_GET_VARS['topic_id']; 
if(!$topic_id) $topic_id = $HTTP_GET_VARS['t']; 
if(!$topic_id) $topic_id = $HTTP_GET_VARS['p']; 
$rating = $HTTP_POST_VARS['rating']; 
if(!$rating) $rating = $HTTP_GET_VARS['rating']; 
$mode = $HTTP_POST_VARS['mode']; 
if(!$mode) $rating = $HTTP_GET_VARS['mode'];


//
//Make Configuration Array As Mandatory!
//
$rate_config = array();

$sql = "SELECT *
FROM " . RATE_CONFIG_TABLE;

if ( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, "Couldn't retrieve rating config data.", "", __LINE__, __FILE__, $sql);
}

while ( $row = $db->sql_fetchrow($result) )
{
	$config_name = $row['config_name'];
	$config_value = $row['config_value'];
	$rate_config[$config_name] = $config_value;
}
$db->sql_freeresult($result);

//
// Functions
//
function rating_insert($user_id, $topic_id, $rating)
{
	global $db, $user_ip, $rate_config;

	if ($user_id == ANONYMOUS)
	{
		//Get the next anon user ID
		$user_id = $rate_config['anon_rate_id'];

		$sql = "INSERT INTO " . RATE_TABLE .
		" VALUES (" . $user_id . ", " . $topic_id . ", " . $rating . ", '" . $user_ip . "', " . time() . ")";

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't INSERT rating data.  If you see Duplicate entry error below, then rating_config table is incorrect or anon_rate_id sequence!", "", __LINE__, __FILE__, $sql);
		}
		$db->sql_freeresult($result);

		//Decrement anon user ID
		$sql = "UPDATE " . RATE_CONFIG_TABLE .
		" SET config_value ='" . ($user_id - 1) .
		"' WHERE config_name = 'anon_rate_id'";

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Error updating the anon_rate_id in config table...This could cause rating problems.", "", __LINE__, __FILE__, $sql);
		}
		$db->sql_freeresult($result);

		$rate_config['anon_rate_id'] = $user_id - 1;
	}
	else
	{
		$sql = "INSERT INTO " . RATE_TABLE .
		" VALUES (" . $user_id . ", " . $topic_id . ", " . $rating . ", '" . $user_ip . "', " . time() . ")";

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't INSERT rating data.  If you see Duplicate entry error below, then user has already rated.", "", __LINE__, __FILE__, $sql);
		}
		$db->sql_freeresult($result);
	}
}

function rating_change($user_id, $topic_id, $rating)
{
	global $db, $rate_config, $user_ip;

	if ($user_id == ANONYMOUS)
	{
		$sql = "UPDATE " . RATE_TABLE .
		" SET rating =" . $rating .
		", rate_time =" . time() .
		" WHERE user_id >= " . $rate_config['anon_rate_id'] .
		" AND rater_ip = '" . $user_ip .
		"' AND topic_id = " . $topic_id;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't UPDATE anonymous rating data.", "", __LINE__, __FILE__, $sql);
		}
		$db->sql_freeresult($result);
	}
	else
	{
		$sql = "UPDATE " . RATE_TABLE .
		" SET rating =" . $rating .
		", rate_time =" . time() .
		" WHERE user_id = " . $user_id .
		" AND topic_id = " . $topic_id;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't UPDATE rating data.", "", __LINE__, __FILE__, $sql);
		}
		$db->sql_freeresult($result);
	}
}

function rating_stats($topic_id)
{
	//Returns 1D array of average, minimum, maximum, number_of_rates for $topic_id
	global $db;

	$sql = "SELECT AVG(rating) AS average,
	MIN(rating) AS minimum,
	MAX(rating) AS maximum,
	COUNT(rating) AS number_of_rates
	FROM " . RATE_TABLE .
	" WHERE topic_id = " . $topic_id;

	if ( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't SELECT rating data.", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	return $row;
}

function rating_info($user_id, $topic_id)
{
	//Returns rating for $user_id + $topic_id
	global $db, $rate_config, $user_ip;

	if ($user_id == ANONYMOUS)
	{
		$sql = "SELECT rating FROM " . RATE_TABLE .
		" WHERE user_id >= " . $rate_config['anon_rate_id'] .
		" AND rater_ip = '" . $user_ip .
		"' AND topic_id = " . $topic_id;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't retrieve rating data.", "", __LINE__, __FILE__, $sql);
		}

		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

	}
	else
	{
		$sql = "SELECT rating FROM " . RATE_TABLE .
		" WHERE user_id = " . $user_id .
		" AND topic_id = " . $topic_id;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't retrieve rating data.", "", __LINE__, __FILE__, $sql);
		}

		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
	}
	return $row['rating'];
}

function rating_inserted($user_id, $topic_id)
{
	//Returns 1 for already_inserted for $user_id + $topic_id
	global $db, $user_ip, $rate_config;

	if ($user_id == ANONYMOUS)
	{
		$status = 0;
		if ($rate_config['check_anon_ip'])
		{
			$sql = "SELECT COUNT(rater_ip) AS user_ip_number FROM " . RATE_TABLE .
			" WHERE rater_ip = '" . $user_ip .
			"' AND topic_id = " . $topic_id .
			" AND user_id >= " . $rate_config['anon_rate_id'];

			if ( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't retrieve rating data.", "", __LINE__, __FILE__, $sql);
			}

			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			( $row['user_ip_number'] ) ? $status=1 : $status=0;
		}
	}
	else
	{

		$sql = "SELECT user_id FROM " . RATE_TABLE .
		" WHERE user_id = " . $user_id .
		" AND topic_id = " . $topic_id;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't retrieve rating data.", "", __LINE__, __FILE__, $sql);
		}

		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		($user_id == $row['user_id']) ? $status=1 : $status=0;
	}
	return $status;
}

function rate_auth($user_id, $forum_id, $topic_id)
{
	global $db, $userdata;
	//Returns 0 for not authorized
	//Returns 1 for able to rate
	//Returns 2 for private
	//Returns 3 for none

	//Get forum_id info
	$sql = "SELECT auth_rate FROM " . FORUMS_TABLE .
	" WHERE forum_id = " . $forum_id;
	if ( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Error getting forum data.", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$forum_row = $row['auth_rate'];
	$db->sql_freeresult($result);

	$value = 0;
	//First check topic_id
	//NOT IMPLEMENTED YET
	if ($topic_id != $topic_id) $value = 1;
	//If topic_id check ok, check if NONE (which is -1)
	else if ($forum_row == -1) $value = 3;
	//Check if ALL
	else if ($forum_row == AUTH_ALL) $value = 1;
	//Now check if REG
	else if ($forum_row == AUTH_REG && $user_id != ANONYMOUS) $value = 1;
	//Now check if PRIVATE
	else if ($forum_row == AUTH_ACL) $value = 2;
	//Now check if MOD
	else if ($forum_row == AUTH_MOD)
	{
		/* MESSY AUTH_MOD CODE START THAT I COPIED FROM INDEX.PHP SO IT WORKS :) */
		$sql = "SELECT aa.forum_id, g.group_name, g.group_id, g.group_single_user, u.user_id, u.username
		FROM " . AUTH_ACCESS_TABLE . " aa, " . USER_GROUP_TABLE . " ug, " . GROUPS_TABLE . " g, " . USERS_TABLE . " u
		WHERE aa.auth_mod = " . TRUE . "
		AND ug.group_id = aa.group_id
		AND g.group_id = aa.group_id
		AND u.user_id = ug.user_id
		ORDER BY aa.forum_id, g.group_id, u.user_id";
		if(!$q_forum_mods = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Could not query forum moderator information", "", __LINE__, __FILE__, $sql);
		}
		$forum_mods_list = $db->sql_fetchrowset($q_forum_mods);

		for($i = 0; $i < count($forum_mods_list); $i++)
		{
			if($forum_mods_list[$i]['group_single_user'] || !$forum_mods_list[$i]['group_id'])
			{
				$forum_mods_single_user[$forum_mods_list[$i]['forum_id']][] = 1;

				$forum_mods_name[$forum_mods_list[$i]['forum_id']][] = $forum_mods_list[$i]['username'];
				$forum_mods_id[$forum_mods_list[$i]['forum_id']][] = $forum_mods_list[$i]['user_id'];
			}
			else
			{
				$forum_mods_single_user[$forum_mods_list[$i]['forum_id']][] = 0;

				$forum_mods_name[$forum_mods_list[$i]['forum_id']][] = $forum_mods_list[$i]['group_name'];
				$forum_mods_id[$forum_mods_list[$i]['forum_id']][] = $forum_mods_list[$i]['group_id'];
			}
		}

		for($mods = 0; $mods < count($forum_mods_name[$forum_id]); $mods++)
		{
			if ($user_id == $forum_mods_id[$forum_id][$mods]) $value = 1;
		}
		$sql = "SELECT user_level
		FROM " . USERS_TABLE .
		" WHERE user_id = " . $user_id;
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Error getting user data.", "", __LINE__, __FILE__, $sql);
		}
		$row = $db->sql_fetchrow($result);
		$auth_row = $row['user_level'];
		if ($auth_row == ADMIN) $value = 1;
		/*MESSY AUTH_MOD CODE END */
	}
	//Now check if ADMIN
	else if ($forum_row == AUTH_ADMIN)
	{
		$sql = "SELECT user_level FROM " . USERS_TABLE .
		" WHERE user_id = " . $user_id;
		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Error getting user data.", "", __LINE__, __FILE__, $sql);
		}
		$row = $db->sql_fetchrow($result);
		$auth_row = $row['user_level'];
		if ($auth_row == ADMIN) $value = 1;
	}
	//If all that fails then no access
	else $value = 0;

	return $value;
}

function id_to_name($user_id)
{
	global $db;

	$sql = "SELECT username
	FROM " . USERS_TABLE . "
	WHERE user_id = " . $user_id . "
	LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query users table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	if ($row['username'] == "")
	{
		$row['username'] = "Anonymous";
	}

	return $row['username'];
}

function id_to_title($topic_id)
{
	global $db;

	$sql = "SELECT topic_title
	FROM " . TOPICS_TABLE . "
	WHERE topic_id = " . $topic_id . "
	LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query topics table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row['topic_title'];
}

function id_to_forum($forum_id)
{
	global $db;

	$sql = "SELECT forum_name
	FROM " . FORUMS_TABLE . "
	WHERE forum_id = " . $forum_id . "
	LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query forums table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row['forum_name'];
}

function last_rater($topic_id)
{
	global $db;

	$sql = "SELECT user_id
	FROM " . RATE_TABLE . "
	WHERE topic_id = " . $topic_id . "
	ORDER BY rate_time DESC
	LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query ratings table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row['user_id'];
}

function last_rater_time($topic_id)
{
	global $db;

	$sql = "SELECT rate_time
	FROM " . RATE_TABLE . "
	WHERE topic_id = " . $topic_id . "
	ORDER BY rate_time DESC
	LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query ratings table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row['rate_time'];
}

function topic_to_forum($topic_id)
{
	global $db;

	$sql = "SELECT forum_id
	FROM " . TOPICS_TABLE . "
	WHERE topic_id = " . $topic_id . "
	LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query topics table", "", __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return $row['forum_id'];
}

function generate_topic_id_sql($topics_row)
{
	global $db;
	//Returns a little string for SQL of topics based on your
	//2-D array sent

	$topic_id_sql = "";
	for($i = 0; $i < count($topics_row); $i++)
	{
		if( $topic_id_sql != "")
		{
			$topic_id_sql .= ", ";
		}
		$topic_id_sql .= $topics_row[$i]['topic_id'];
	}
	return $topic_id_sql;
}

function generate_forum_id_sql($forums_row)
{
	global $db, $userdata;
	//Generate a little list of forums we can view for SQL

	for ($i=0; $i < count($forums_row); $i++)
	{
		$is_auth = auth('auth_view', $forums_row[$i]['forum_id'], $userdata);
		if ($is_auth['auth_view']) {
			if( $forum_id_sql != "")
			{
				$forum_id_sql .= ", ";
			}
			$forum_id_sql .= $forums_row[$i]['forum_id'];
		}
	}
	return $forum_id_sql;
}

function get_forum_array()
{
	global $db, $userdata;
	//Get a nice 2-D array of forums to deal with
	$sql = "SELECT forum_id, forum_name
	FROM " . FORUMS_TABLE . "
	WHERE auth_rate <> -1 ";

	if ( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't query rating auth data.", "", __LINE__, __FILE__, $sql);
	}
	$forums_row = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	return $forums_row;
}

function get_rated_topics_array()
{
	global $db;
	//Get a nice 2-D array of rated topics to deal with
	$sql = "SELECT topic_id
	FROM " . RATE_TABLE;

	if ( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't query rating topic data.", "", __LINE__, __FILE__, $sql);
	}
	$topics_row = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	return $topics_row;
}

function get_authorized_topics_array($forum_id_sql, $topic_id_sql)
{
	global $db;
	if ( $forum_id_sql != "" && $topic_id_sql != "" )
	{
		//Get a nice 2-D array of topics to we can view now based on the list of rated ones
		$sql = "SELECT topic_id
		FROM " . TOPICS_TABLE . "
		WHERE topic_id IN ($topic_id_sql)
		AND forum_id IN ($forum_id_sql)";

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't query rating topic data.", "", __LINE__, __FILE__, $sql);
		}
		$authed_topics_row = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);
	}
	else
	{
		$auth_topics_row['forum_name'] = "Not Available";
	}
	return $authed_topics_row;
}

function get_top_rated_topics_array($topic_id_sql, $return_limit)
{
	global $db, $rate_config;
	if ( $topic_id_sql != "" )
	{
		//Get the top admin control panel defined top rated topics as a 2-D array
		$sql = "SELECT	AVG(rating) AS average, COUNT(rating) AS rating_number, MIN(rating) AS min, MAX(rating) AS max, topic_id
		FROM " . RATE_TABLE . "
		WHERE topic_id IN ($topic_id_sql)
		GROUP BY topic_id DESC
		HAVING rating_number >= " . $rate_config['min_rates_number'] . "
		ORDER BY average DESC
		LIMIT " . $return_limit;

		if ( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't query rating data.", "", __LINE__, __FILE__, $sql);
		}
		$top_rated_row = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);
	}

	return $top_rated_row;
}

?>