<?php
/***************************************************************************
 *								statistics.php
 *                            -------------------
 *   begin                : Sat, Aug 31, 2002
 *   copyright            : (C) 2002 Meik Sievertsen
 *   email                : acyd.burn@gmx.de
 *
 *   $Id: statistics.php,v 2.1.0 2002/09/04 meik Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$stats_config = array();

$sql = 'SELECT *
FROM ' . STATS_CONFIG_TABLE;
	 
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not query statistics config table', '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$stats_config[$row['config_name']] = $row['config_value'];
}

include($phpbb_root_path . 'includes/functions_stats.' . $phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_statistics.' . $phpEx);
	
include('includes/page_header.php');
	
$module_rows = get_module_list_from_db();

while (list($module_id, $module_name) = each($module_rows))
{

	$module_name = trim($module_name);

	if (module_auth_check($module_id, $userdata))
	{
		$template->_tpldata = array();
		unset($template->compiled_code['module_tpl']);
		unset($template->uncompiled_code['module_tpl']);

		$sql = "SELECT update_time, module_data_time, module_data_cache, name
		FROM " . MODULES_TABLE . "
		WHERE module_id = " . $module_id;

		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
		}

		$row = $db->sql_fetchrow($result);
		$modules_dir = trim($row['name']);

		if (($row['module_data_time'] + ($row['update_time'] * 60)) > time())
		{
			$cm_template_data = unserialize(stripslashes($row['module_data_cache']));
			
			$template->_tpldata = $cm_template_data;
		
			$template->set_filenames(array(
				'module_tpl' => './../../' . $phpbb_root_path . $stats_config['modules_dir'] . '/' . $modules_dir . '/module.tpl')
			);
	
			$template->pparse('module_tpl');
		}
		else
		{
			$module_info = get_module_info($module_id);
			$return_limit = $stats_config['return_limit'];
				
			@include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.' . $phpEx);
			@include($phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_name . '/lang_' . $board_config['default_lang'] . '/lang.' . $phpEx);
			include($phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_name . '/module.php');
				
			$sql = "UPDATE " . MODULES_TABLE . "
			SET module_data_cache = '" . addslashes(serialize($template->_tpldata)) . "',
			module_data_time = " . time() . "
			WHERE module_id = " . $module_id;

			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, $lang['Stat_Module_Error'], '', __LINE__, __FILE__, $sql);
			}

			$template->set_filenames(array(
				'module_tpl' => './../../' . $phpbb_root_path . $stats_config['modules_dir'] . '/' . $module_info['dname'] . '/module.tpl')
			);
	
			$template->pparse('module_tpl');
		}
		
		print '<br />';
	}
}
	
$sql = "UPDATE " . STATS_CONFIG_TABLE . "
SET config_value = " . (intval($stats_config['page_views']) + 1) . "
WHERE (config_name = 'page_views')";

if (!$db->sql_query($sql))
{
	message_die(GENERAL_ERROR, $lang['Stat_Config_Error'], '', __LINE__, __FILE__, $sql);
}

$template->set_filenames(array(
	'body' => 'statistics.tpl')
);
	
$template->assign_vars(array(
	'VIEWED_INFO' => sprintf($lang['Viewed_Info'], $stats_config['page_views']),
	'L_STATISTICS' => $lang['Statistics'],
	'INSTALL_INFO' => sprintf($lang['Install_Info'], create_date($board_config['default_dateformat'], $board_config['board_startdate'], $board_config['board_timezone'])),
	'VERSION_INFO' => ( isset($lang['Version_Info']) ) ? sprintf($lang['Version_Info'], $stats_config['version']) : '')
);
	
$template->assign_block_vars('main_bottom',array());

$template->pparse('body');

include('includes/page_tail.php');
?>